function varargout = Databaser(varargin)
% DATABASER M-file for Databaser.fig
%      DATABASER, by itself, creates a new DATABASER or raises the existing
%      singleton*.
%
%      H = DATABASER returns the handle to a new DATABASER or the handle to
%      the existing singleton*.
%
%      DATABASER('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in DATABASER.M with the given input arguments.
%
%      DATABASER('Property','Value',...) creates a new DATABASER or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before Databaser_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to Databaser_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help Databaser

% Last Modified by GUIDE v2.5 20-Jun-2012 10:27:58

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @Databaser_OpeningFcn, ...
                   'gui_OutputFcn',  @Databaser_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before Databaser is made visible.
function Databaser_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to Databaser (see VARARGIN)

% Choose default command line output for Databaser
handles.output = hObject;

% Logo = imread('USC_Logo.jpg');                                              %insert logo
% axes(handles.LogoAxes)
% image(Logo)
% axis equal,axis off

% determine whether to use forward slash or back slash
switch (ismac||isunix)
    case 1
        handles.PathSep = '/';
    case 0
        handles.PathSep = '\';
end

handles.CurrentStartFolder = cd;


handles.IsThisAMac = ismac;
handles.ConfigFile = [];
handles.ActiveExperiment = '';                                              %initalize experiment
handles.ActiveSession = '';
handles.RootDirectory = cd;
handles.FilesToIncorporateList = cell(1000,10);
handles.FilesToIncorporateDisplay = cell(1000,10);
handles.AnalyzeFileList = [];
handles.AnalyzeFileDisplay = [];
handles.PublishFileDisplay = [];
handles.TrialInputList = [];
handles.PathForAddTrials = [];
handles.IntoTrialsList = [];

handles.PublishFileList = [];
handles.PathForAddResults = [];

handles.CollectionInput = [];
handles.PathForInputFiles = [];

handles.NotebookFile = [];

% create handles for all the helper functions
s = what('HelperFunctions');
handles.HelperFunctions.Path = s.path;
handles.HelperFunctions.Files = [s.m' s.mex']';

% create handles for the reader functions
handles.ReaderClassPath = [handles.RootDirectory handles.PathSep 'Readers'];
handles = UpdateReaderList(handles);

% create handles for the analysis functions
handles.AnalyzeClassPath = [handles.RootDirectory handles.PathSep 'AnalysisMethods'];
handles = UpdateAnalysisMethodList(handles);

% create handles for the publishing functions
handles.PublishClassPath = [handles.RootDirectory handles.PathSep 'PublishingMethods'];
handles = UpdatePublishingMethodList(handles);

% create handles for the collection functions
handles.CollectionClassPath = [handles.RootDirectory handles.PathSep 'CollectionMethods'];
handles = UpdateCollectionMethodList(handles);

%
handles.WikiPath = [handles.RootDirectory handles.PathSep 'Wiki'];
handles = UpdateWikiList(handles);

% set up the window to be machine independent
set(handles.figure1,'resize','on')
    
% Update handles structure
guidata(hObject, handles);

set(gcf,'WindowStyle','normal','handlevisibility','off');


% UIWAIT makes Databaser wait for user response (see UIRESUME)
% uiwait(handles.figure1);

function handles = UpdateWikiList(handles)

strsep = EnableHelperFunction([],{'strsep.m'});

handles.WikiNames = [];
handles.WikiHandles = [];
s = dir(handles.WikiPath);
cd(handles.WikiPath)

k = 1;

for i = 1:length(s)
    temp = strsep(s(i).name,'.');
    if s(i).isdir == 0 && strcmp(temp{2},'pdf') == 1 
        handles.WikiNames{k} = temp{1};
        k = k+1;
    end
end
set(handles.LabWikiListbox,'value',1);
set(handles.LabWikiListbox,'string',handles.WikiNames);

cd(handles.RootDirectory)

function handles = UpdateAnalysisMethodList(handles)
handles.AnalysisMethodNames = [];
handles.AnalysisMethodHandles = [];
s = what(handles.AnalyzeClassPath);
cd(s.path)
for i = 1:length(s.m)
    File = s.m{i};
    handles.AnalysisMethodNames{i} = File;
    handles.AnalysisMethodHandles{i} = str2func(File(1:end-2));
end
set(handles.AnalysisMethodsListBox,'value',1);
set(handles.AnalysisMethodsListBox,'string',handles.AnalysisMethodNames);

cd(handles.RootDirectory)

function handles = UpdatePublishingMethodList(handles)
handles.PublishingMethodNames = [];
handles.PublishingMethodHandles = [];
s = what(handles.PublishClassPath);
cd(s.path)
for i = 1:length(s.m)
    File = s.m{i};
    handles.PublishingMethodNames{i} = File;
    handles.PublishingMethodHandles{i} = str2func(File(1:end-2));
end
%if length(s.m) ~= 0
    set(handles.PublishingMethodsListBox,'value',1);
    set(handles.PublishingMethodsListBox,'string',handles.PublishingMethodNames);
%end
cd(handles.RootDirectory)

function handles = UpdateReaderList(handles)
handles.ReaderNames = [];
handles.ReaderHandles = [];
s = what(handles.ReaderClassPath);
cd(s.path)
for i = 1:length(s.m)
    File = s.m{i};
    handles.ReaderNames{i} = File;
    handles.ReaderHandles{i} = str2func(File(1:end-2));
end
set(handles.ReaderListBox,'string',handles.ReaderNames);
cd(handles.RootDirectory)

function handles = UpdateCollectionMethodList(handles)
handles.CollectionMethodNames = [];
handles.CollectionMethodHandles = [];
s = what(handles.CollectionClassPath);
cd(s.path)
for i = 1:length(s.m)
    File = s.m{i};
    handles.CollectionMethodNames{i} = File;
    handles.CollectionMethodHandles{i} = str2func(File(1:end-2));
end
set(handles.CollectionMethodsListBox,'string',handles.CollectionMethodNames);
cd(handles.RootDirectory)

% --- Outputs from this function are returned to the command line.
function varargout = Databaser_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --------------------------------------------------------------------
function FileMenu_Callback(hObject, eventdata, handles)
% hObject    handle to FileMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function NewDatabaseMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to NewDatabaseMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function uipushtool1_ClickedCallback(hObject, eventdata, handles)
% hObject    handle to uipushtool1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function ExperimentMenu_Callback(hObject, eventdata, handles)
% hObject    handle to ExperimentMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function SessionMenu_Callback(hObject, eventdata, handles)
% hObject    handle to SessionMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function TrialMenu_Callback(hObject, eventdata, handles)
% hObject    handle to TrialMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function AnalyzeMenu_Callback(hObject, eventdata, handles)
% hObject    handle to AnalyzeMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function PublishMenu_Callback(hObject, eventdata, handles)
% hObject    handle to PublishMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function NewExperimentMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to NewExperimentMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

CurrentDirectory = cd;

ExperimentParentDirectory = uigetdir(cd,'Choose a folder where the experiment folder will go');
if ExperimentParentDirectory ~= 0
    ExperimentName = inputdlg('What is the name of the experiment?','Experiment Name')
    if isempty(ExperimentName) == 0
        ExperimentName = ExperimentName{1};
        mkdir([ExperimentParentDirectory,handles.PathSep,ExperimentName])
        handles.ActiveExperiment = [ExperimentParentDirectory,handles.PathSep,ExperimentName];
        set(handles.ActiveExperimentIndicator,'string',handles.ActiveExperiment)
    end
end
guidata(handles.figure1,handles)

% --------------------------------------------------------------------
function OpenExperimentMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to OpenExperimentMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles.ActiveExperiment = uigetdir;
if handles.ActiveExperiment ~= 0
    set(handles.ActiveExperimentIndicator,'string',handles.ActiveExperiment)
end
    
guidata(handles.figure1,handles)

% --------------------------------------------------------------------
function CloseExperimentMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to CloseExperimentMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles.ActiveExperiment = '';
set(handles.ActiveExperimentIndicator,'string',handles.ActiveExperiment)
guidata(handles.figure1,handles);


% --------------------------------------------------------------------
function AddTrialsMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to AddTrialsMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

ReadersDone = 'No';
i = 1;      % counter running across all input files
InputFileCount = 1;

switch isempty(handles.PathForAddTrials)
    case 1
        InputPath = handles.RootDirectory;
    case 0
        InputPath = handles.PathForAddTrials;
end
ReaderName = cell(1,1);
WriteToTrialFile = 'Yes';
while strcmp(ReadersDone,'No') == 1
    [ReaderFile,ReaderPath] = uigetfile('Readers/*.m','Select a reader');
    switch ReaderFile
        case 0
            WriteToTrialFile = 'No';
            break;
        otherwise
            cd(ReaderPath);
            ReaderHandle = str2func(ReaderFile(1:end-2));
            cd(handles.RootDirectory);
            InputsDone = 'No';
            c = 1;  % counter running across all input files for the given reader
    end
    while strcmp(InputsDone,'No') == 1
        cd(InputPath);
        [InputFile,InputPath] = uigetfile('*.*','Select an input for the reader');
        switch InputFile
            case 0  % break out of the inputs file loop
                break;
            otherwise
                InputFiles{c} = [InputPath InputFile];
                AllInputFilesPath{InputFileCount} = InputPath;
                AllInputFilesFile{InputFileCount} = InputFile;
                InputFileCount = InputFileCount+1;
                c = c+1;
                InputsDone = questdlg('Have you specified all inputs to this reader?','');
                switch InputsDone
                    case 'Yes' % execute the reader on the given inputs
                        set(handles.ProgramStatusIndicator,'string','Processing input files');
                        pause(0.1)
                        [ReaderOutput{i},ReaderName{i},TrialName{i},TrialDescription{i}] = ReaderHandle(InputFiles,handles.HelperFunctions);
                        set(handles.ProgramStatusIndicator,'string','')
                        i = i+1;
                    case 'No' % get more input files (do nothing)
                        
                    case 'Cancel' % break out of the inputs while loop
                        cd(handles.RootDirectory)
                        break;
                end
        end
    end
    ReadersDone = questdlg('Have you specified all the readers for this trial?','');
    switch ReadersDone
        case 'Yes' % continue in the program
            break;
        case 'No' % continue getting more readers (do nothing)
            
        case 'Cancel' % stop the writing of the trial file
            WriteToTrialFile = 'No';
            cd(handles.RootDirectory)
            break;       
    end
end

% this part should only execute if ReaderName has been populated
if strcmp(WriteToTrialFile,'Yes') == 1
    
    % names of all the fields in the current reading of input files
    for i = 1:length(ReaderName)                                 
        Trial.(ReaderName{i}) = ReaderOutput{i}; 
    end
    
    % extract a name for the trial from the appropriate file
    TrialFileName = [];
    for i = 1:length(TrialName)                                             
        if isempty(TrialName{i}) == 0
            TrialFileName = TrialName{i};
        end
    end
    
    % extract a description for the trial from the appropriate file
    TrialFileDescription = [];
    for i = 1:length(TrialDescription)                                             
        if isempty(TrialDescription{i}) == 0
            TrialFileDescription = TrialDescription{i};
        end
    end
    
    % is the data going to be added to an existing file or will a new file
    % be created?
    Append = questdlg('Are you appending to a trial?','');
    switch Append
        case 'Yes'  % append to an existing trial
            cd(handles.ActiveSession)
            
            %get the existing trial name
            [TrialFile,TrialPath] = uigetfile('*.*','Select the trial to be appended');
            
            %load the existing trial
            load([TrialPath TrialFile])
            
            % add fields to the trial
            for i = 1:length(ReaderName)                                            
                Trial.(ReaderName{i}) = ReaderOutput{i}; 
            end
             
            Names = fieldnames(Trial);
            c = cell(length(Names),1);
            DesInd = find(strcmp(Names,'Description')==1);
            c = Names;
            c{DesInd} = c{end};
            c{end} = 'Description';
            
            Trial = orderfields(Trial,c);
            
            % save the appended trial
            cd([handles.ActiveSession handles.PathSep TrialFile(1:end-4)]);
            save(TrialFile,'Trial');
            
            % copy additional raw files to directory
            
            for i = 1:length(AllInputFilesPath)
                copyfile([AllInputFilesPath{i} AllInputFilesFile{i}],AllInputFilesFile{i})
            end
            
            cd(handles.RootDirectory)
            set(handles.ProgramStatusIndicator,'string',['Trial "' TrialFile(1:end-4) '" was appended and raw data files copied']);
            
        case 'No'   % create a new trial
            cd(handles.ActiveSession)

            % create a location to store raw data files
            if isempty(TrialFileName) == 1
                errordlg('The readers you selected did not produce a name for the trial file');
                return;
            else
                if isdir([handles.ActiveSession handles.PathSep TrialFileName])
                    cd([handles.ActiveSession handles.PathSep TrialFileName]);
                else
                    mkdir([handles.ActiveSession handles.PathSep TrialFileName]);
                    cd([handles.ActiveSession handles.PathSep TrialFileName]);
                end
            end
            for i = 1:length(AllInputFilesPath)
                copyfile([AllInputFilesPath{i} AllInputFilesFile{i}],AllInputFilesFile{i})
            end
            
            % add fields to the trial
            for i = 1:length(ReaderName)                                            
                Trial.(ReaderName{i}) = ReaderOutput{i}; 
            end
            
            if isempty(TrialFileDescription) == 1
                errordlg('WARNING: The readers you selected did not produce a description for the trial file');
            end
            Trial.Description = TrialFileDescription;
            
            % save the appended trial
            save(TrialFileName,'Trial');
        
            cd(handles.RootDirectory);
            set(handles.ProgramStatusIndicator,'string',['A new trial "' TrialFileName '" was created and raw data files copied']);

        case 'Cancel'
      
    end % switch
end %if

% --------------------------------------------------------------------
function NewSessionMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to NewSessionMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if strcmp(handles.ActiveExperiment,'') == 1
    errordlg('Please active an experiment.','Experiment Error');
else
    SessionName = inputdlg('What is the name of the session?','Session Name');
    SessionName = SessionName{1};
    mkdir([handles.ActiveExperiment handles.PathSep SessionName])
    handles.ActiveSession = [handles.ActiveExperiment handles.PathSep SessionName];
    set(handles.ActiveSessionIndicator,'string',handles.ActiveSession);
end

guidata(handles.figure1,handles)

% --------------------------------------------------------------------
function OpenSessionMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to OpenSessionMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if strcmp(handles.ActiveExperiment,'') == 1
    errordlg('Please active an experiment.','Experiment Error');
else
    cd(handles.ActiveExperiment);
    handles.ActiveSession = uigetdir;
    if handles.ActiveSession ~= 0
        set(handles.ActiveSessionIndicator,'string',handles.ActiveSession)
    end
    cd(handles.RootDirectory);
end
    
guidata(handles.figure1,handles)

% --------------------------------------------------------------------
function CloseSessionMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to CloseSessionMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles.ActiveSession = '';
set(handles.ActiveSessionIndicator,'string',handles.ActiveSession);

guidata(handles.figure1,handles);

function ActiveExperimentIndicator_Callback(hObject, eventdata, handles)
% hObject    handle to ActiveExperimentIndicator (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of ActiveExperimentIndicator as text
%        str2double(get(hObject,'String')) returns contents of
%        ActiveExperimentIndicator as a double

% --- Executes during object creation, after setting all properties.
function ActiveExperimentIndicator_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ActiveExperimentIndicator (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function ActiveSessionIndicator_Callback(hObject, eventdata, handles)
% hObject    handle to ActiveSessionIndicator (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of ActiveSessionIndicator as text
%        str2double(get(hObject,'String')) returns contents of ActiveSessionIndicator as a double


% --- Executes during object creation, after setting all properties.
function ActiveSessionIndicator_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ActiveSessionIndicator (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function ActiveTrialIndicator_Callback(hObject, eventdata, handles)
% hObject    handle to ActiveTrialIndicator (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of ActiveTrialIndicator as text
%        str2double(get(hObject,'String')) returns contents of ActiveTrialIndicator as a double


% --- Executes during object creation, after setting all properties.
function ActiveTrialIndicator_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ActiveTrialIndicator (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in ParserListbox.
function ParserListbox_Callback(hObject, eventdata, handles)
% hObject    handle to ParserListbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns ParserListbox contents as cell array
%        contents{get(hObject,'Value')} returns selected item from ParserListbox


% --- Executes during object creation, after setting all properties.
function ParserListbox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ParserListbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in AddParser.
function AddParser_Callback(hObject, eventdata, handles)
% hObject    handle to AddParser (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in RemoveParser.
function RemoveParser_Callback(hObject, eventdata, handles)
% hObject    handle to RemoveParser (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)



function ActiveParserIndicator_Callback(hObject, eventdata, handles)
% hObject    handle to ActiveParserIndicator (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of ActiveParserIndicator as text
%        str2double(get(hObject,'String')) returns contents of ActiveParserIndicator as a double


% --- Executes during object creation, after setting all properties.
function ActiveParserIndicator_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ActiveParserIndicator (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --------------------------------------------------------------------
function HelpMenu_Callback(hObject, eventdata, handles)
% hObject    handle to HelpMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function SelectParserMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to SelectParserMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

cd Parsers

ActiveParser = uigetfile('*.m','Select a Parser');
if ActiveParser ~= 0
    handles.ActiveParserFunctionHandle= str2func(ActiveParser);
    handles.ActiveParser = ActiveParser;
    set(handles.ActiveParserIndicator,'string',handles.ActiveParser)
end

cd ..

guidata(handles.figure1,handles);



function ProgramStatusIndicator_Callback(hObject, eventdata, handles)
% hObject    handle to ProgramStatusIndicator (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of ProgramStatusIndicator as text
%        str2double(get(hObject,'String')) returns contents of ProgramStatusIndicator as a double


% --- Executes during object creation, after setting all properties.
function ProgramStatusIndicator_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ProgramStatusIndicator (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in listbox5.
function listbox5_Callback(hObject, eventdata, handles)
% hObject    handle to listbox5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns listbox5 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox5


% --- Executes during object creation, after setting all properties.
function listbox5_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in TrialsToAnalyzeListBox.
function TrialsToAnalyzeListBox_Callback(hObject, eventdata, handles)
% hObject    handle to TrialsToAnalyzeListBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns TrialsToAnalyzeListBox contents as cell array
%        contents{get(hObject,'Value')} returns selected item from TrialsToAnalyzeListBox


% --- Executes during object creation, after setting all properties.
function TrialsToAnalyzeListBox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to TrialsToAnalyzeListBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in AddTrialsToAnalyze.
function AddTrialsToAnalyze_Callback(hObject, eventdata, handles)
% hObject    handle to AddTrialsToAnalyze (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

strsep = EnableHelperFunction(handles.HelperFunctions,'strsep.m');
SelectTrialFromResult = EnableHelperFunction(handles.HelperFunctions,'SelectTrialFromResult.m');
cd('HelperFunctions');

switch strcmp(handles.ActiveSession,'')
    case 1
        errordlg('Please make a session active');
        cd(handles.RootDirectory);
        return;
    otherwise
        ActiveSessionContents = dir(handles.ActiveSession);
        DirectoryInd = find([ActiveSessionContents.isdir]==1);
        for i = 1:length(ActiveSessionContents(DirectoryInd))
            Input(i).AppliedTo = ActiveSessionContents(DirectoryInd(i)).name;
        end
        [handleToSelect,SelectedTrials] = SelectTrialFromResult(Input);
        switch isempty(SelectedTrials)
            case 0
                for i = 1:length(SelectedTrials)
                   NewTrialsToAnalyze{i} = [handles.ActiveSession handles.PathSep Input(SelectedTrials(i)).AppliedTo handles.PathSep Input(SelectedTrials(i)).AppliedTo '.mat']; 
                end
            case 1
                cd(handles.RootDirectory);
                return;
        end
end

handles.AnalyzeFileList = [handles.AnalyzeFileList NewTrialsToAnalyze];


cd(handles.RootDirectory);

set(handles.TrialsToAnalyzeListBox,'value',1);
handles = AnalyzeFileListToDisplay(handles);
set(handles.TrialsToAnalyzeListBox,'string',handles.AnalyzeFileDisplay);

guidata(handles.figure1,handles);

% --- Executes on button press in RemoveTrialsToAnalyze.
function RemoveTrialsToAnalyze_Callback(hObject, eventdata, handles)
% hObject    handle to RemoveTrialsToAnalyze (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

WhichTrialToRemove = get(handles.TrialsToAnalyzeListBox,'Value');
handles.AnalyzeFileList(WhichTrialToRemove) = [];
handles.AnalyzeFileDisplay(WhichTrialToRemove) = [];
set(handles.TrialsToAnalyzeListBox,'value',length(handles.AnalyzeFileList));
handles = AnalyzeFileListToDisplay(handles);
set(handles.TrialsToAnalyzeListBox,'string',handles.AnalyzeFileDisplay);

guidata(handles.figure1,handles)


% --- Executes on selection change in AnalysisMethodsListBox.
function AnalysisMethodsListBox_Callback(hObject, eventdata, handles)
% hObject    handle to AnalysisMethodsListBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns AnalysisMethodsListBox contents as cell array
%        contents{get(hObject,'Value')} returns selected item from AnalysisMethodsListBox

Type = get(handles.figure1,'selectiontype');

if strcmp(Type,'open') == 1
    SelectedAnalysisMethods = get(handles.AnalysisMethodsListBox,'value');
    SelectedTrials = get(handles.TrialsToAnalyzeListBox,'value');

    for MethodNum = 1:length(handles.AnalysisMethodHandles)
       if ismember(MethodNum,SelectedAnalysisMethods) == 1'
            if isempty(handles.AnalyzeFileList) == 0
                AnalysisInput.Files = handles.AnalyzeFileList(SelectedTrials);
            else
                AnalysisInput.Files = [];
            end
            AnalysisInput.HelperFunctions = handles.HelperFunctions;
            AnalysisInput.PathSep = handles.PathSep;
            AnalysisInput.ProgramStatusIndicator = handles.ProgramStatusIndicator;
            AnalysisOutput{MethodNum} = handles.AnalysisMethodHandles{MethodNum}(AnalysisInput);
       end
    end

    set(handles.ProgramStatusIndicator,'string','Analysis method(s) completed. Ready.','foregroundcolor','w');
end


% --- Executes during object creation, after setting all properties.
function AnalysisMethodsListBox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to AnalysisMethodsListBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in AnalyzePushButton.
function AnalyzePushButton_Callback(hObject, eventdata, handles)
% hObject    handle to AnalyzePushButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

SelectedAnalysisMethods = get(handles.AnalysisMethodsListBox,'value');
SelectedTrials = get(handles.TrialsToAnalyzeListBox,'value');

for MethodNum = 1:length(handles.AnalysisMethodHandles)
   if ismember(MethodNum,SelectedAnalysisMethods) == 1'
        if isempty(handles.AnalyzeFileList) == 0
            AnalysisInput.Files = handles.AnalyzeFileList(SelectedTrials);
        else
            AnalysisInput.Files = [];
        end
        AnalysisInput.HelperFunctions = handles.HelperFunctions;
        AnalysisInput.PathSep = handles.PathSep;
        AnalysisInput.ProgramStatusIndicator = handles.ProgramStatusIndicator;
        AnalysisOutput{MethodNum} = handles.AnalysisMethodHandles{MethodNum}(AnalysisInput);
   end
end

set(handles.ProgramStatusIndicator,'string','Analysis method(s) completed. Ready.','foregroundcolor','w');


% --------------------------------------------------------------------
function SetPathForAddTrial_Callback(hObject, eventdata, handles)
% hObject    handle to SetPathForAddTrial (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles.ActiveSession

switch isempty(handles.ActiveSession) 
    case 0
       cd(handles.ActiveSession)
       handles.PathForAddTrials = uigetdir;
       cd(handles.RootDirectory);
    case 1
       handles.PathForAddTrials = uigetdir; 
end

guidata(handles.figure1,handles);



function TrialPathControl_Callback(hObject, eventdata, handles)
% hObject    handle to TrialPathControl (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of TrialPathControl as text
%        str2double(get(hObject,'String')) returns contents of TrialPathControl as a double


% --- Executes during object creation, after setting all properties.
function TrialPathControl_CreateFcn(hObject, eventdata, handles)
% hObject    handle to TrialPathControl (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in AddMethod.
function AddMethod_Callback(hObject, eventdata, handles)
% hObject    handle to AddMethod (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

Input = inputdlg('Enter A Name for the Method');

switch isempty(Input)
    case 1
        
    case 0
        FirstLine = ['function AnalysisOutput = ' Input{1} '(AnalysisInput)\n'];
        fid = fopen([handles.AnalyzeClassPath handles.PathSep Input{1} '.m'],'w');
        fprintf(fid,FirstLine);
        fprintf(fid,'\n');
        fprintf(fid,'%% AnalysisInput\n');
        fprintf(fid,'%% .Files - cell array of data files for all selected trials\n');
        fprintf(fid,'%% .HelperFunctions - cell array of helper functions to be used with EnableHelperFunction\n');
        fprintf(fid,'%% .PathSep - / in mac and \\ in windows\n');
        fprintf(fid,'%%\n');
        fprintf(fid,'%% don''t forget to save your result appropriately\n');
        fprintf(fid,'%%\n');
        fprintf(fid,'%% ----------------- Your code here!!! ----------------\n');
        fprintf(fid,'%%\n');
        fprintf(fid,'AnalysisOutput = 1;');



        
        fclose(fid);
        handles = UpdateAnalysisMethodList(handles);
        guidata(handles.figure1,handles);
end


% --------------------------------------------------------------------
function EditAnalysisMethod_Callback(hObject, eventdata, handles)
% hObject    handle to EditAnalysisMethod (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

Selected = get(handles.AnalysisMethodsListBox,'value');

List = get(handles.AnalysisMethodsListBox,'string');


edit([handles.AnalyzeClassPath handles.PathSep List{Selected}]);


% --------------------------------------------------------------------
function RightClickMethodsList_Callback(hObject, eventdata, handles)
% hObject    handle to RightClickMethodsList (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in ClearAllTrialsForAnalysis.
function ClearAllTrialsForAnalysis_Callback(hObject, eventdata, handles)
% hObject    handle to ClearAllTrialsForAnalysis (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

L = length(handles.AnalyzeFileList);

for i = 1:L
    handles.AnalyzeFileList(L-(i-1)) = [];
    handles.AnalyzeFileDisplay(L-(i-1)) = [];
end

handles = AnalyzeFileListToDisplay(handles);
set(handles.TrialsToAnalyzeListBox,'value',1);
set(handles.TrialsToAnalyzeListBox,'string',handles.AnalyzeFileDisplay); 
    
guidata(handles.figure1,handles)


% --- Executes on selection change in ResultsToPublishListBox.
function ResultsToPublishListBox_Callback(hObject, eventdata, handles)
% hObject    handle to ResultsToPublishListBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns ResultsToPublishListBox contents as cell array
%        contents{get(hObject,'Value')} returns selected item from ResultsToPublishListBox


% --- Executes during object creation, after setting all properties.
function ResultsToPublishListBox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ResultsToPublishListBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in PublishingMethodsListBox.
function PublishingMethodsListBox_Callback(hObject, eventdata, handles)
% hObject    handle to PublishingMethodsListBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns PublishingMethodsListBox contents as cell array
%        contents{get(hObject,'Value')} returns selected item from PublishingMethodsListBox


% --- Executes during object creation, after setting all properties.
function PublishingMethodsListBox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to PublishingMethodsListBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in PublishPushButton.
function PublishPushButton_Callback(hObject, eventdata, handles)
% hObject    handle to PublishPushButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

SelectedPublishingMethods = get(handles.PublishingMethodsListBox,'value');
SelectedResults = get(handles.ResultsToPublishListBox,'value');

for MethodNum = 1:length(handles.PublishingMethodHandles)
   if ismember(MethodNum,SelectedPublishingMethods) == 1
       try
        PublishInput.ResultFiles = handles.PublishFileList(SelectedResults);
       catch
           PublishInput.ResultFiles = [];
       end
       
       PublishInput.HelperFunctions = handles.HelperFunctions;
       PublishInput.PathSep = handles.PathSep;
       PublishInput.ProgramStatusIndicator = handles.ProgramStatusIndicator;
       PublishOutput = handles.PublishingMethodHandles{MethodNum}(PublishInput);
   end
end

% --- Executes on button press in AddResultsToPublish.
function AddResultsToPublish_Callback(hObject, eventdata, handles)
% hObject    handle to AddResultsToPublish (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

strsep = EnableHelperFunction(handles.HelperFunctions,'strsep.m');

switch isempty(handles.PathForAddResults)
    case 0
        cd(handles.PathForAddResults)
        [ResultFile,ResultPath] = uigetfile('*.*','Select a result','multiselect','on');
        cd(handles.RootDirectory)
    case 1
        [ResultFile,ResultPath] = uigetfile('*.*','Select a trial','multiselect','on');
end

ResultFileTemp = ResultFile;
clear('ResultFile'); 

if iscell(ResultFileTemp) == 0
    ResultFile{1} = ResultFileTemp;
else
    ResultFile = ResultFileTemp;
end

switch ResultFile{1}
    case 0
        
    otherwise
        for i = 1:length(ResultFile)
            ResultFile{i} = [ResultPath ResultFile{i}];
        end
        handles.PublishFileList = [handles.PublishFileList ResultFile];
        set(handles.ResultsToPublishListBox,'value',1);
        handles = PublishResultListToDisplay(handles);
        set(handles.ResultsToPublishListBox,'string',handles.PublishFileDisplay);
        
        guidata(handles.figure1,handles);
end

% --- Executes on button press in RemoveResultsToPublish.
function RemoveResultsToPublish_Callback(hObject, eventdata, handles)
% hObject    handle to RemoveResultsToPublish (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

WhichResultToRemove = get(handles.ResultsToPublishListBox,'Value');

handles.PublishFileList(WhichResultToRemove) = [];
handles.PublishFileDisplay(WhichResultToRemove) = [];

handles = PublishResultListToDisplay(handles);

set(handles.ResultsToPublishListBox,'value',1);
set(handles.ResultsToPublishListBox,'string',handles.PublishFileDisplay);

guidata(handles.figure1,handles)


% --- Executes on button press in ClearAllResultsToPublish.
function ClearAllResultsToPublish_Callback(hObject, eventdata, handles)
% hObject    handle to ClearAllResultsToPublish (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

L = length(handles.PublishFileList);

for i = 1:L
    handles.PublishFileList(L-(i-1)) = [];
    handles.PublishFileDisplay(L-(i-1)) = [];
end

handles = PublishResultListToDisplay(handles);
set(handles.ResultsToPublishListBox,'value',1);
set(handles.ResultsToPublishListBox,'string',handles.PublishFileDisplay); 
    
guidata(handles.figure1,handles)

% --- Executes on button press in MoveResultUp.
function MoveResultUp_Callback(hObject, eventdata, handles)
% hObject    handle to MoveResultUp (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

Selected = get(handles.ResultsToPublishListBox,'Value');

switch Selected
    case 1
        
    otherwise
        temp = handles.PublishFileList{Selected};
        handles.PublishFileList{Selected} = handles.PublishFileList{Selected-1};
        handles.PublishFileList{Selected-1} = temp;
end

handles = PublishResultListToDisplay(handles);
set(handles.ResultsToPublishListBox,'string',handles.PublishFileDisplay);
set(handles.ResultsToPublishListBox,'value',Selected-1);


        
guidata(handles.figure1,handles);

% --- Executes on button press in MoveResultDown.
function MoveResultDown_Callback(hObject, eventdata, handles)
% hObject    handle to MoveResultDown (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

Selected = get(handles.ResultsToPublishListBox,'Value');

switch Selected
    case length(handles.PublishFileList)
        
    otherwise
        temp = handles.PublishFileList{Selected};
        handles.PublishFileList{Selected} = handles.PublishFileList{Selected+1};
        handles.PublishFileList{Selected+1} = temp;
end

handles = PublishResultListToDisplay(handles);
set(handles.ResultsToPublishListBox,'string',handles.PublishFileDisplay);
set(handles.ResultsToPublishListBox,'value',Selected+1);
        
guidata(handles.figure1,handles);

% --- Executes on button press in AddPublishingMethod.
function AddPublishingMethod_Callback(hObject, eventdata, handles)
% hObject    handle to AddPublishingMethod (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

Input = inputdlg('Enter A Name for the Method');

switch isempty(Input)
    case 1
        
    case 0
        FirstLine = ['function PublishOutput = ' Input{1} '(PublishInput)\n'];
        fid = fopen([handles.PublishClassPath handles.PathSep Input{1} '.m'],'w');
        fprintf(fid,FirstLine);
        fprintf(fid,'%% Publishing Methods are .m functions that look at result files and produce new result files or publication figures\n');
        fprintf(fid,'%% PublishInput\n');
        fprintf(fid,'%%     .ResultFiles - cell array of file names passed to the method\n');
        fprintf(fid,'%%     .HelperFunctions - cell array of helper function names to be used with EnableHelperFunction\n');
        fprintf(fid,'%%     .PathSep - path separator ''/'' in mac/linux and ''\\'' in windows\n');
        fprintf(fid,'%%     .ProgramStatusIndicator - a handle to the Program Status Indicator on the front panel so that status can be updated from within the reader\n');
        fprintf(fid,'%% PublishOutput - not currently used\n');
        fprintf(fid,'%%\n');
        fprintf(fid,'\n');
        fprintf(fid,'BaseDirectory = cd;\n');
        fprintf(fid,'\n');
        fprintf(fid,'try\n');
        fprintf(fid,'\n');
        fprintf(fid,'%%----------- Your code here !!! ---------------\n');
        fprintf(fid,'\n');
        fprintf(fid,'catch err\n');
        fprintf(fid,['  set(PublishInput.ProgramStatusIndicator,''string'',''' Input{1} ' had an error. See Matlab window for details.'',''foregroundcolor'',''r'');drawnow;\n']);
        fprintf(fid,'  cd(BaseDirectory);\n');
        fprintf(fid,'  rethrow(err);\n');
        fprintf(fid,'end\n');
        fprintf(fid,'\n');
        fprintf(fid,'PublishOutput = 1;\n');
        
        fclose(fid);
        handles = UpdatePublishingMethodList(handles);
        guidata(handles.figure1,handles);
end

open([handles.PublishClassPath handles.PathSep Input{1} '.m']);


% --------------------------------------------------------------------
function EditPublishingMethod_Callback(hObject, eventdata, handles)
% hObject    handle to EditPublishingMethod (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

Selected = get(handles.PublishingMethodsListBox,'value');

List = get(handles.PublishingMethodsListBox,'string');


edit([handles.PublishClassPath handles.PathSep List{Selected}]);


% --------------------------------------------------------------------
function RightClickPublishList_Callback(hObject, eventdata, handles)
% hObject    handle to RightClickPublishList (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function SetResultsPath_Callback(hObject, eventdata, handles)
% hObject    handle to SetResultsPath (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles.PathForAddResults = uigetdir;

guidata(handles.figure1,handles);


% --------------------------------------------------------------------
function GetInfo_Callback(hObject, eventdata, handles)
% hObject    handle to GetInfo (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if isempty(strfind(func2str(get(gco,'Callback')),'PublishingMethodsListBox')) == 0
    Selected = get(handles.PublishingMethodsListBox,'value');
    [handles.PublishClassPath handles.PublishingMethodNames{Selected}]
    HelpComments = help([handles.PublishClassPath handles.PathSep handles.PublishingMethodNames{Selected}]);
    msgbox(HelpComments)
end

if isempty(strfind(func2str(get(gco,'Callback')),'AnalysisMethodsListBox')) == 0
    Selected = get(handles.AnalysisMethodsListBox,'value');
    HelpComments = help([handles.AnalyzeClassPath handles.PathSep handles.AnalysisMethodNames{Selected}]);
    msgbox(HelpComments)
end

if isempty(strfind(func2str(get(gco,'Callback')),'ReaderListBox')) == 0
    Selected = get(handles.ReaderListBox,'value');
    HelpComments = help([handles.ReaderClassPath handles.PathSep handles.ReaderNames{Selected}]);
    msgbox(HelpComments)
end

% --- Executes on selection change in PublishingVersionSelector.
function PublishingVersionSelector_Callback(hObject, eventdata, handles)
% hObject    handle to PublishingVersionSelector (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns PublishingVersionSelector contents as cell array
%        contents{get(hObject,'Value')} returns selected item from PublishingVersionSelector


% --- Executes during object creation, after setting all properties.
function PublishingVersionSelector_CreateFcn(hObject, eventdata, handles)
% hObject    handle to PublishingVersionSelector (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in AnalysisVersionSelector.
function AnalysisVersionSelector_Callback(hObject, eventdata, handles)
% hObject    handle to AnalysisVersionSelector (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns AnalysisVersionSelector contents as cell array
%        contents{get(hObject,'Value')} returns selected item from AnalysisVersionSelector


% --- Executes during object creation, after setting all properties.
function AnalysisVersionSelector_CreateFcn(hObject, eventdata, handles)
% hObject    handle to AnalysisVersionSelector (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in RemoveAnalysisMethod.
function RemoveAnalysisMethod_Callback(hObject, eventdata, handles)
% hObject    handle to RemoveAnalysisMethod (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

Selected = get(handles.AnalysisMethodsListBox,'value');

Answer = questdlg(['Are you sure you want to delete the method ' handles.AnalysisMethodNames{Selected} ' ?']);

switch Answer
    case 'Yes'
        delete([handles.AnalyzeClassPath handles.PathSep handles.AnalysisMethodNames{Selected}]);
        handles = UpdateAnalysisMethodList(handles);
    case 'No'
        
    case 'Cancel'
end

guidata(handles.figure1,handles);


% --- Executes on button press in RemovePublishingMethod.
function RemovePublishingMethod_Callback(hObject, eventdata, handles)
% hObject    handle to RemovePublishingMethod (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

Selected = get(handles.PublishingMethodsListBox,'value');

Answer = questdlg(['Are you sure you want to delete the method ' handles.PublishingMethodNames{Selected} ' ?']);

switch Answer
    case 'Yes'
        file = [handles.PublishClassPath handles.PathSep handles.PublishingMethodNames{Selected}];
        copyfile(file,'~/.Trash');
        delete(file);
        handles = UpdatePublishingMethodList(handles);
    case 'No'
        
    case 'Cancel'
end

guidata(handles.figure1,handles);


% --- Executes on selection change in ReaderListBox.
function ReaderListBox_Callback(hObject, eventdata, handles)
% hObject    handle to ReaderListBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns ReaderListBox contents as cell array
%        contents{get(hObject,'Value')} returns selected item from ReaderListBox


% --- Executes during object creation, after setting all properties.
function ReaderListBox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ReaderListBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in BuildPushButton.
function BuildPushButton_Callback(hObject, eventdata, handles)
% hObject    handle to BuildPushButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

strsep = EnableHelperFunction(handles.HelperFunctions,'strsep.m');

SelectedReader = get(handles.ReaderListBox,'value');
ReaderList = get(handles.ReaderListBox,'string');
ReaderHandle = handles.ReaderHandles{SelectedReader};

NumFiles = 1;
while isempty(handles.FilesToIncorporateList{NumFiles,1}) == 0
    NumFiles = NumFiles + 1;
end
NumFiles = NumFiles - 1;

Append = get(handles.AppendCheckBox,'value');

if NumFiles == 0
    ReaderInput.HelperFunctions = handles.HelperFunctions;
    ReaderInput.ProgramStatusIndicator = handles.ProgramStatusIndicator;
    ReaderInput.RootDirectory = handles.RootDirectory;  
    ReaderInput.PathSep = handles.PathSep;
    ReaderInput.DatabaserFigureHandle = handles.figure1;
    ReaderInput.ActiveExperiment = handles.ActiveExperiment;
    ReaderInput.ActiveSession = handles.ActiveSession;
    ReaderOutput = ReaderHandle(ReaderInput);
end

for File = 1:NumFiles
    set(handles.FilesToIncorporateListBox,'value',File);
    pause(0.5);
    i = 1;
    while isempty(handles.FilesToIncorporateList{File,i}) == 0
        InputFiles{i} = handles.FilesToIncorporateList{File,i};
        i = i+1;
    end
    ReaderInput.Files = InputFiles;
    ReaderInput.HelperFunctions = handles.HelperFunctions;
    ReaderInput.ProgramStatusIndicator = handles.ProgramStatusIndicator;
    ReaderInput.RootDirectory = handles.RootDirectory;  
    ReaderInput.PathSep = handles.PathSep;
    ReaderInput.DatabaserFigureHandle = handles.figure1;
    ReaderInput.ActiveExperiment = handles.ActiveExperiment;
    ReaderInput.ActiveSession = handles.ActiveSession;
    
    
    switch Append
        case 1
            home;
            ReaderInput.IntoTrial = handles.IntoTrialsList{File};
            set(handles.ProgramStatusIndicator,'string',['Running ' ReaderList{SelectedReader}],'foregroundcolor','g'); drawnow;
            pause(1);
            ReaderOutput = ReaderHandle(ReaderInput);
            set(handles.IntoTrialsListBox,'value',File);
            load(handles.IntoTrialsList{File});
            Trial.(ReaderOutput.ReaderName) = ReaderOutput.Data;
            save(handles.IntoTrialsList{File},'Trial');
            temp = strsep(handles.IntoTrialsList{File},handles.PathSep);
            set(handles.ProgramStatusIndicator,'string',['A new field "' ReaderOutput.ReaderName '" was appended to trial "' temp{end}(1:end-4) '".'],'foregroundcolor','g');
            pause(2);
            set(handles.ProgramStatusIndicator,'string','Ready.');
        case 0
            ReaderOutput = ReaderHandle(ReaderInput);
            cd(handles.ActiveSession);
            
            if isempty(ReaderOutput.Data) == 1
                cd(handles.RootDirectory);
                return;
            end

            % create a location to store raw data files
            if isempty(ReaderOutput.TrialName) == 1
                             cd(handles.RootDirectory);

            else
                if isdir([handles.ActiveSession handles.PathSep ReaderOutput.TrialName])
                    cd([handles.ActiveSession handles.PathSep ReaderOutput.TrialName]);
                else
                    mkdir([handles.ActiveSession handles.PathSep ReaderOutput.TrialName]);
                    cd([handles.ActiveSession handles.PathSep ReaderOutput.TrialName]);
                end
                
             switch isempty(ReaderOutput.TrialDescription)
                case 1
                    errordlg('WARNING: The readers you selected did not produce a description for the trial file');
                    Trial.Description = '';
                otherwise
                    Trial.Description = ReaderOutput.TrialDescription;
            end
                
                Trial.(ReaderOutput.ReaderName) = ReaderOutput.Data;

                % save the appended trial
                save(ReaderOutput.TrialName,'Trial');
        
                cd(handles.RootDirectory);
                set(handles.ProgramStatusIndicator,'string',['A new trial "' ReaderOutput.TrialName '" was created and raw data files copied']);
                pause(0.5)
            end
    end
end

set(handles.ProgramStatusIndicator,'string','Build finished. Ready.','foregroundcolor','w');


% --- Executes on selection change in FilesToIncorporateListBox.
function FilesToIncorporateListBox_Callback(hObject, eventdata, handles)
% hObject    handle to FilesToIncorporateListBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns FilesToIncorporateListBox contents as cell array
%        contents{get(hObject,'Value')} returns selected item from FilesToIncorporateListBox


% --- Executes during object creation, after setting all properties.
function FilesToIncorporateListBox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to FilesToIncorporateListBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in AddFilesToIncorporate.
function AddFilesToIncorporate_Callback(hObject, eventdata, handles)
% hObject    handle to AddFilesToIncorporate (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

strsep = EnableHelperFunction(handles.HelperFunctions,'strsep.m');

WhichInput = get(handles.InputNumberSelector,'value');

switch isempty(handles.PathForAddTrials)
    case 0
        switch get(handles.Set2FtpForBuild,'value')
            case 0
                cd(handles.PathForAddTrials)
                [InFile,InPath] = uigetfile('*.*','Select a trial','multiselect','on');
                cd(handles.RootDirectory)
            case 1
                cd('HelperFunctions')
                    [crap,handles.PathForAddTrials,InFile] = FtpDirSel(handles.Brachioplex,'Select an input file');
                cd('..');
                cd('FtpTemp');
                cd(handles.Brachioplex,handles.PathForAddTrials);
                mget(handles.Brachioplex,InFile);
                InPath = [cd handles.PathSep];
                cd('..');
        end
    case 1
        [InFile,InPath] = uigetfile('*.*','Select a trial','multiselect','on');
end

if iscell(InFile) == 1
    InputFile = InFile;
    InputPath = InPath;
else
    InputFile{1} = InFile;
    InputPath = InPath;
end

switch InputFile{1}
    case 0
        
    otherwise
        CurrentLength = 1;
        while isempty(handles.FilesToIncorporateList{CurrentLength,WhichInput}) == 0
           CurrentLength = CurrentLength+1; 
        end
        CurrentLength = CurrentLength-1;
        for i = 1:length(InputFile)
            handles.FilesToIncorporateList{CurrentLength+i,WhichInput} = [InputPath InputFile{i}];
        end
        set(handles.FilesToIncorporateListBox,'value',1);
        handles = FilesToIncorporateListToDisplay(handles);
        set(handles.FilesToIncorporateListBox,'string',handles.FilesToIncorporateDisplay(:,WhichInput)); 
        guidata(handles.figure1,handles);
end

function handles = AnalyzeFileListToDisplay(handles)

strsep = EnableHelperFunction(handles.HelperFunctions,'strsep.m');

for i = 1:length(handles.AnalyzeFileList)
   if isempty(handles.AnalyzeFileList{i}) == 0
       vec = strsep(handles.AnalyzeFileList{i},handles.PathSep);
       handles.AnalyzeFileDisplay{i} = [num2str(i) '. ' vec{end}]; 
   else 
       handles.AnalyzeFileDisplay{i} = [];
   end
end

function handles = PublishResultListToDisplay(handles)

strsep = EnableHelperFunction(handles.HelperFunctions,'strsep.m');

for i = 1:length(handles.PublishFileList)
   if isempty(handles.PublishFileList{i}) == 0
       vec = strsep(handles.PublishFileList{i},'/');
       if isdir(handles.PublishFileList{i}) == 1
        handles.PublishFileDisplay{i} = ['<HTML><FONT color="red">' num2str(i) '. '  vec{end} '</FONT></HTML>']; 
       else
        handles.PublishFileDisplay{i} = [num2str(i) '. ' vec{end}];   
       end
   else 
       handles.PublishFileDisplay{i} = [];
   end
end

function handles = FilesToIncorporateListToDisplay(handles)

strsep = EnableHelperFunction(handles.HelperFunctions,'strsep.m');

for i = 1:size(handles.FilesToIncorporateList,1)
    for j = 1:size(handles.FilesToIncorporateList,2)
        if isempty(handles.FilesToIncorporateList{i,j}) == 0
            vec = strsep(handles.FilesToIncorporateList{i,j},handles.PathSep);
            handles.FilesToIncorporateDisplay{i,j} = [num2str(i) '. ' vec{end}];
        else
            handles.FilesToIncorporateDisplay{i,j} = [];
        end
    end
end


% --- Executes on button press in RemoveFilesToIncorporate.
function RemoveFilesToIncorporate_Callback(hObject, eventdata, handles)
% hObject    handle to RemoveFilesToIncorporate (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

WhichInput = get(handles.InputNumberSelector,'value');
Selected = get(handles.FilesToIncorporateListBox,'value');

for i = Selected+1:size(handles.FilesToIncorporateList,1)
    temp = handles.FilesToIncorporateList{i,WhichInput};
    handles.FilesToIncorporateList{i-1,WhichInput} = temp;
end
% set(handles.FilesToIncorporateListBox,'value',Selected-1);

handles = FilesToIncorporateListToDisplay(handles);
set(handles.FilesToIncorporateListBox,'string',handles.FilesToIncorporateDisplay(:,WhichInput));
guidata(handles.figure1,handles)


% --- Executes on button press in ClearAllFilesToIncorporate.
function ClearAllFilesToIncorporate_Callback(hObject, eventdata, handles)
% hObject    handle to ClearAllFilesToIncorporate (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

WhichInput = get(handles.InputNumberSelector,'value');

handles.FilesToIncorporateList(:,WhichInput) = cell(1000,1);

handles = FilesToIncorporateListToDisplay(handles);
set(handles.FilesToIncorporateListBox,'string',handles.FilesToIncorporateDisplay(:,WhichInput));
set(handles.InputNumberSelector,'value',1);
set(handles.FilesToIncorporateListBox,'value',1);
    
guidata(handles.figure1,handles)


% --- Executes on selection change in InputNumberSelector.
function InputNumberSelector_Callback(hObject, eventdata, handles)
% hObject    handle to InputNumberSelector (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns InputNumberSelector contents as cell array
%        contents{get(hObject,'Value')} returns selected item from InputNumberSelector

WhichInput = get(handles.InputNumberSelector,'value');

handles = FilesToIncorporateListToDisplay(handles);
set(handles.FilesToIncorporateListBox,'string',handles.FilesToIncorporateDisplay(:,WhichInput));

guidata(handles.figure1,handles);


% --- Executes during object creation, after setting all properties.
function InputNumberSelector_CreateFcn(hObject, eventdata, handles)
% hObject    handle to InputNumberSelector (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in AppendCheckBox.
function AppendCheckBox_Callback(hObject, eventdata, handles)
% hObject    handle to AppendCheckBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of AppendCheckBox


% --- Executes on selection change in IntoTrialsListBox.
function IntoTrialsListBox_Callback(hObject, eventdata, handles)
% hObject    handle to IntoTrialsListBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns IntoTrialsListBox contents as cell array
%        contents{get(hObject,'Value')} returns selected item from IntoTrialsListBox


% --- Executes during object creation, after setting all properties.
function IntoTrialsListBox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to IntoTrialsListBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in AddTrialsForFileIncorporation.
function AddTrialsForFileIncorporation_Callback(hObject, eventdata, handles)
% hObject    handle to AddTrialsForFileIncorporation (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

SelectTrialFromResult = EnableHelperFunction(handles.HelperFunctions,'SelectTrialFromResult.m');
cd('HelperFunctions');

switch strcmp(handles.ActiveSession,'')
    case 1
        errordlg('Please make a session active');
        cd(handles.RootDirectory);
    otherwise
        ActiveSessionContents = dir(handles.ActiveSession);
        DirectoryInd = find([ActiveSessionContents.isdir]==1);
        for i = 1:length(ActiveSessionContents(DirectoryInd))
            Input(i).AppliedTo = ActiveSessionContents(DirectoryInd(i)).name;
        end
        [Output,SelectedTrials] = SelectTrialFromResult(Input);
        for i = 1:length(SelectedTrials)
           Name = [handles.ActiveSession handles.PathSep Input(SelectedTrials(i)).AppliedTo handles.PathSep Input(SelectedTrials(i)).AppliedTo '.mat'];
           handles.IntoTrialsList{length(handles.IntoTrialsList)+1} = Name; 
        end
end

set(handles.IntoTrialsListBox,'value',1);
set(handles.IntoTrialsListBox,'string',handles.IntoTrialsList);

cd(handles.RootDirectory);
guidata(handles.figure1,handles);


% --- Executes on button press in RemoveTrialsForFileIncorporation.
function RemoveTrialsForFileIncorporation_Callback(hObject, eventdata, handles)
% hObject    handle to RemoveTrialsForFileIncorporation (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

SelTrial = get(handles.IntoTrialsListBox,'value');

set(handles.IntoTrialsListBox,'value',1);
handles.IntoTrialsList(SelTrial) = [];
set(handles.IntoTrialsListBox,'string',handles.IntoTrialsList); 
guidata(handles.figure1,handles);


% --- Executes on button press in ClearAllTrialsForFileIncorporation.
function ClearAllTrialsForFileIncorporation_Callback(hObject, eventdata, handles)
% hObject    handle to ClearAllTrialsForFileIncorporation (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

L = length(handles.IntoTrialsList);

for i = 1:L
    handles.IntoTrialsList(L-(i-1)) = [];
end

set(handles.IntoTrialsListBox,'string',handles.IntoTrialsList); 
    
guidata(handles.figure1,handles)


% --- Executes on button press in SetFilePath.
function SetFilePath_Callback(hObject, eventdata, handles)
% hObject    handle to SetFilePath (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

switch get(handles.Set2FtpForBuild,'value')
    case 0
        InputPath = uigetdir;
        handles.PathForAddTrials = InputPath;
    case 1
        handles.Brachioplex = ftp(get(handles.FtpAddress,'string'));
        cd('HelperFunctions')
        [crap,handles.PathForAddTrials] = FtpDirSel(handles.Brachioplex,'Select a directory for input files');
        cd('..');
end

set(handles.PathForAddTrialsIndicator,'string',handles.PathForAddTrials);

guidata(handles.figure1,handles);


% --- Executes on button press in SetPathForResultsPushButton.
function SetPathForResultsPushButton_Callback(hObject, eventdata, handles)
% hObject    handle to SetPathForResultsPushButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles.PathForAddResults = uigetdir;

set(handles.ResultPathIndicator,'string',handles.PathForAddResults);

guidata(handles.figure1,handles);


% --------------------------------------------------------------------
function ViewInArrayEditor_Callback(hObject, eventdata, handles)
% hObject    handle to ViewInArrayEditor (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

Selected = get(handles.TrialsToAnalyzeListBox,'value');

load(handles.AnalyzeFileList{Selected});
assignin('base','Trial',Trial);
openvar('Trial')

try
    load([handles.AnalyzeFileList{Selected}(1:end-4) '_Aux.mat']);
    assignin('base','TrialAux',TrialAux);
    openvar('TrialAux')
catch
    
end

% --------------------------------------------------------------------
function RightClickTrials_Callback(hObject, eventdata, handles)
% hObject    handle to RightClickTrials (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in SetPathForInputFiles.
function SetPathForInputFiles_Callback(hObject, eventdata, handles)
% hObject    handle to SetPathForInputFiles (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

switch get(handles.SetToFtp,'value')
    case 0
        InputPath = uigetdir;
        handles.PathForInputFiles = InputPath;
    case 1
        handles.Brachioplex = ftp('192.168.11.50');
        cd('HelperFunctions')
        [crap,handles.FtpPathForInputFiles] = FtpDirSel(handles.Brachioplex,'Select a directory for input files');
        cd('..');
end

guidata(handles.figure1,handles);

% --- Executes on selection change in TrialInputListBox.
function TrialInputListBox_Callback(hObject, eventdata, handles)
% hObject    handle to TrialInputListBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns TrialInputListBox contents as cell array
%        contents{get(hObject,'Value')} returns selected item from TrialInputListBox


% --- Executes during object creation, after setting all properties.
function TrialInputListBox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to TrialInputListBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in CreateNewTrialInput.
function CreateNewTrialInput_Callback(hObject, eventdata, handles)
% hObject    handle to CreateNewTrialInput (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

CollectionArgs.HelperFunctions = handles.HelperFunctions;
CollectionArgs.PathSep = handles.PathSep;
CollectionArgs.ProgramStatusIndicator = handles.ProgramStatusIndicator;
CollectionArgs.DatabaserHandles = handles;

SelMethod = get(handles.CollectionMethodsListBox,'value');
handles.CollectionMethodHandles{SelMethod}(CollectionArgs);


guidata(handles.figure1,handles);



% --- Executes on button press in RemoveTrialInput.
function RemoveTrialInput_Callback(hObject, eventdata, handles)
% hObject    handle to RemoveTrialInput (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

SelInput = get(handles.TrialInputListBox,'value');
handles.CollectionInput(SelInput) = [];
set(handles.TrialInputListBox,'value',1);
set(handles.TrialInputListBox,'string',{handles.CollectionInput.Name});

guidata(handles.figure1,handles);


% --- Executes on button press in ClearAllTrialInputs.
function ClearAllTrialInputs_Callback(hObject, eventdata, handles)
% hObject    handle to ClearAllTrialInputs (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles.CollectionInput = [];

set(handles.TrialInputListBox,'value',1);
set(handles.TrialInputListBox,'string',{});

guidata(handles.figure1,handles);

% --- Executes on button press in LoadTrialInput.
function LoadTrialInput_Callback(hObject, eventdata, handles)
% hObject    handle to LoadTrialInput (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

Ans = questdlg('WARNING: This will erase your current experiment plan and replace with the saved one. Continue?');

switch Ans
    case 'Cancel'
    case 'No'
    case 'Yes'
        [CollectionInputFile CollectionInputPath] = uigetfile('*.mat');
        switch CollectionInputFile
            case 0
            otherwise
                load([CollectionInputPath handles.PathSep CollectionInputFile]);
                handles.CollectionInput = CollectionInput;
                set(handles.TrialInputListBox,'string',{handles.CollectionInput.Name});
        end
end

guidata(handles.figure1,handles);


% --- Executes on button press in InsertTrialInput.
function InsertTrialInput_Callback(hObject, eventdata, handles)
% hObject    handle to InsertTrialInput (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on selection change in CollectionMethodsListBox.
function CollectionMethodsListBox_Callback(hObject, eventdata, handles)
% hObject    handle to CollectionMethodsListBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns CollectionMethodsListBox contents as cell array
%        contents{get(hObject,'Value')} returns selected item from CollectionMethodsListBox


% --- Executes during object creation, after setting all properties.
function CollectionMethodsListBox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to CollectionMethodsListBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --------------------------------------------------------------------
function EditCollectionMethod_Callback(hObject, eventdata, handles)
% hObject    handle to EditCollectionMethod (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

Selected = get(handles.CollectionMethodsListBox,'value');

List = get(handles.CollectionMethodsListBox,'string');


edit([handles.CollectionClassPath handles.PathSep List{Selected}]);

% --------------------------------------------------------------------
function RightClickCollectionList_Callback(hObject, eventdata, handles)
% hObject    handle to RightClickCollectionList (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in SaveTrialInput.
function SaveTrialInput_Callback(hObject, eventdata, handles)
% hObject    handle to SaveTrialInput (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

[SaveFile,SavePath] = uiputfile('*.mat');

switch SaveFile
    case 0
        
    otherwise
        CollectionInput = handles.CollectionInput;
        save([SavePath handles.PathSep SaveFile],'CollectionInput');
end


% --- Executes on button press in CopyInput.
function CopyInput_Callback(hObject, eventdata, handles)
% hObject    handle to CopyInput (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

SelInput = get(handles.TrialInputListBox,'value');
clipboard('copy',[handles.CollectionInput(SelInput).Name '_Input.txt']);

% --- Executes on button press in CopyOutput.
function CopyOutput_Callback(hObject, eventdata, handles)
% hObject    handle to CopyOutput (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

SelInput = get(handles.TrialInputListBox,'value');
clipboard('copy',[handles.CollectionInput(SelInput).Name '_Output.txt']);

% --- Executes on button press in CopyDescription.
function CopyDescription_Callback(hObject, eventdata, handles)
% hObject    handle to CopyDescription (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

SelInput = get(handles.TrialInputListBox,'value');
clipboard('copy',handles.CollectionInput(SelInput).Description);


% --- Executes on button press in WriteInputTextFiles.
function WriteInputTextFiles_Callback(hObject, eventdata, handles)
% hObject    handle to WriteInputTextFiles (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

strsep = EnableHelperFunction(handles.HelperFunctions,'strsep.m');

switch get(handles.SetToFtp,'value')
    case 0
        switch isempty(handles.PathForInputFiles)
            case 1
                errordlg('You need to set a path for the input files');
            case 0
                SelInputs = get(handles.TrialInputListBox,'value');

                for i = SelInputs
                    dlmwrite([handles.PathForInputFiles handles.PathSep handles.CollectionInput(i).Name '_Input.txt'],handles.CollectionInput(i).Data,'delimiter','\t','precision','%.3f');
                end      
        end
    case 1
        switch isempty(handles.FtpPathForInputFiles)
            case 1
                errordlg('You need to set a path for the input files on the ftp server');
            case 0
                SelInput = get(handles.TrialInputListBox,'value');
                
                % write the input file to ftp server
                cd(handles.Brachioplex,handles.FtpPathForInputFiles);
                dlmwrite([handles.CollectionInput(SelInput).Name '_Input.txt'],handles.CollectionInput(SelInput).Data,'delimiter','\t','precision','%.3f');
                mput(handles.Brachioplex,[handles.CollectionInput(SelInput).Name '_Input.txt']);
                delete([handles.CollectionInput(SelInput).Name '_Input.txt']);  
                
                % write input file definition to ftp server
                fid = fopen('CurrentTrialDefinition.txt','w');
                fprintf(fid,handles.CollectionInput(SelInput).Name);
                fprintf(fid,'\n');
                fprintf(fid,handles.CollectionInput(SelInput).Description);
                fprintf(fid,'\n');
                SepFtpPath = strsep(handles.FtpPathForInputFiles,'/');
                
                BplexPath = '';
                SepFtpPath
                for i = 1:length(SepFtpPath)
                    BplexPath = [BplexPath SepFtpPath{i} '\'];
                end
                BplexPathPrint = '';
                for i = 1:length(SepFtpPath)
                    BplexPathPrint = [BplexPathPrint SepFtpPath{i} '\\'];
                end
                BplexPath = ['C:' BplexPath];
                BplexPathPrint = ['C:' BplexPathPrint];
                fprintf(fid,[BplexPathPrint handles.CollectionInput(SelInput).Name '_Input.txt']);
                fprintf(fid,'\n');
                fprintf(fid,[BplexPathPrint handles.CollectionInput(SelInput).Name '_Output.txt']);
                fprintf(fid,'\n');
                fprintf(fid,num2str(handles.CollectionInput(SelInput).NumPatterns));
                fprintf(fid,'\n');
                fprintf(fid,[BplexPathPrint handles.CollectionInput(SelInput).Name '_Log.txt']);
                fclose(fid);
                mput(handles.Brachioplex,'CurrentTrialDefinition.txt');
                delete('CurrentTrialDefinition.txt');
        end
end


% --- Executes on button press in NewNotebook.
function NewNotebook_Callback(hObject, eventdata, handles)
% hObject    handle to NewNotebook (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

[NotebookFile,NotebookPath] = uiputfile('*.mat');

switch NotebookFile
    case 0
    otherwise

Event = [];
save([NotebookPath NotebookFile],'Event');

handles.NotebookFile = [NotebookPath NotebookFile];
load(handles.NotebookFile);
set(handles.CurrentNotebookIndicator,'string',NotebookFile);
end

guidata(handles.figure1,handles);

% --- Executes on button press in OpenNotebook.
function OpenNotebook_Callback(hObject, eventdata, handles)
% hObject    handle to OpenNotebook (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

[NotebookFile,NotebookPath] = uigetfile('*.mat');

switch NotebookFile
    case 0
    otherwise

handles.NotebookFile = [NotebookPath NotebookFile];

load(handles.NotebookFile);
set(handles.CurrentNotebookIndicator,'string',NotebookFile);
end

guidata(handles.figure1,handles);

% --- Executes on button press in AddNotebookEntry.
function AddNotebookEntry_Callback(hObject, eventdata, handles)
% hObject    handle to AddNotebookEntry (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

load(handles.NotebookFile)

CurrentLength = length(Event);

DateAndTime = clock;
    Event(CurrentLength+1).Date = [num2str(DateAndTime(3)) '/' num2str(DateAndTime(2)) '/' num2str(DateAndTime(1))];
    Event(CurrentLength+1).Time = [num2str(DateAndTime(4)) ':' num2str(DateAndTime(5)) ':' num2str(DateAndTime(6))];
    
EventEntry = inputdlg('Entry:');
Event(CurrentLength+1).Entry = EventEntry{1};

save(handles.NotebookFile,'Event');


% --- Executes on button press in ReplaceTrialInput.
function ReplaceTrialInput_Callback(hObject, eventdata, handles)
% hObject    handle to ReplaceTrialInput (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

SelMethod = get(handles.CollectionMethodsListBox,'value');
SelInput = get(handles.TrialInputListBox,'value');

        LenCollectionInput = length(handles.CollectionInput);

        temp = handles.CollectionInput;

        CollectionArgs.HelperFunctions = handles.HelperFunctions;
        CollectionArgs.PathSep = handles.PathSep;

        temp = handles.CollectionMethodHandles{SelMethod}(CollectionArgs);
        
        handles.CollectionInput(SelInput).Data = temp.Data;
        handles.CollectionInput(SelInput).NumPatterns = temp.NumPatterns;

guidata(handles.figure1,handles);


% --- Executes on button press in AddCollectionMethod.
function AddCollectionMethod_Callback(hObject, eventdata, handles)
% hObject    handle to AddCollectionMethod (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

Input = inputdlg('Enter A Name for the Method');

switch isempty(Input)
    case 1
        
    case 0
        FirstLine = ['function CollectionOutput = ' Input{1} '(CollectionInput)\n'];
        fid = fopen([handles.CollectionClassPath handles.PathSep Input{1} '.m'],'w');
        fprintf(fid,FirstLine);
        fprintf(fid,'%% CollectionInput.HelperFunctions (not used)\n');
        fprintf(fid,'%% CollectionArgs.PathSep (a string ''/'' in mac and ''\'' in windows)\n');
        fprintf(fid,'%%\n');
        fprintf(fid,'%%\n');
        fprintf(fid,'%% ------ Insert your code here -----------\n');
        fprintf(fid,'%%\n');
        fprintf(fid,'CollectionOutput = 1;');
        
        fclose(fid);
        handles = UpdateCollectionMethodList(handles);
        guidata(handles.figure1,handles);
end


% --- Executes on button press in RemoveCollectionMethod.
function RemoveCollectionMethod_Callback(hObject, eventdata, handles)
% hObject    handle to RemoveCollectionMethod (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

Selected = get(handles.CollectionMethodsListBox,'value');

Answer = questdlg(['Are you sure you want to delete the method ' handles.CollectionMethodNames{Selected} ' ?']);

switch Answer
    case 'Yes'
        file = [handles.CollectionClassPath handles.PathSep handles.CollectionMethodNames{Selected}];
        copyfile(file,'~/.Trash');
        delete(file);
        set(handles.CollectionMethodsListBox,'value',1);
        handles = UpdateCollectionMethodList(handles);
    case 'No'
        
    case 'Cancel'
end

guidata(handles.figure1,handles);


% --- Executes on button press in CopyTrialName.
function CopyTrialName_Callback(hObject, eventdata, handles)
% hObject    handle to CopyTrialName (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

SelInput = get(handles.TrialInputListBox,'value');
clipboard('copy',handles.CollectionInput(SelInput).Name);


% --- Executes on button press in CopyNumberOfTimePoints.
function CopyNumberOfTimePoints_Callback(hObject, eventdata, handles)
% hObject    handle to CopyNumberOfTimePoints (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

SelInput = get(handles.TrialInputListBox,'value');
clipboard('copy',num2str(size(handles.CollectionInput(SelInput).Data,1)));


% --------------------------------------------------------------------
function RightClickReaderList_Callback(hObject, eventdata, handles)
% hObject    handle to RightClickReaderList (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function EditReader_Callback(hObject, eventdata, handles)
% hObject    handle to EditReader (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

Selected = get(handles.ReaderListBox,'value');

List = get(handles.ReaderListBox,'string');

edit([handles.ReaderClassPath handles.PathSep List{Selected}]);


% --- Executes on button press in ChooseAnalyzeMethodClass.
function ChooseAnalyzeMethodClass_Callback(hObject, eventdata, handles)
% hObject    handle to ChooseAnalyzeMethodClass (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

cd('AnalysisMethods');
handles.AnalyzeClassPath = uigetdir;
cd(handles.RootDirectory);

switch handles.AnalyzeClassPath
    case 0
        return;
    otherwise
        handles = UpdateAnalysisMethodList(handles);
        guidata(handles.figure1,handles);
end




% --- Executes on button press in ChoosePublishMethodClass.
function ChoosePublishMethodClass_Callback(hObject, eventdata, handles)
% hObject    handle to ChoosePublishMethodClass (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

cd('PublishingMethods');
handles.PublishClassPath = uigetdir;
cd(handles.RootDirectory);

switch handles.PublishClassPath
    case 0
        return;
    otherwise
        handles = UpdatePublishingMethodList(handles);
        guidata(handles.figure1,handles);
end


function SearchPathForAddTrials_Callback(hObject, eventdata, handles)
% hObject    handle to SearchPathForAddTrials (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of SearchPathForAddTrials as text
%        str2double(get(hObject,'String')) returns contents of SearchPathForAddTrials as a double

strsep = EnableHelperFunction(handles.HelperFunctions,'strsep.m');

WhichInput = get(handles.InputNumberSelector,'value');

switch isempty(handles.PathForAddTrials)
    case 0
        cd(handles.PathForAddTrials)
        allFilesMatching = dir(get(handles.SearchPathForAddTrials,'string'));
        InPath = handles.PathForAddTrials;
        for dirContInd = 1:length(allFilesMatching)
            InFile{dirContInd} = allFilesMatching(dirContInd).name;
        end
        cd(handles.RootDirectory)
    case 1
        errordlg('Please set a path for adding trials');
        return;
end

if iscell(InFile) == 1
    InputFile = InFile;
    InputPath = InPath;
else
    InputFile{1} = InFile;
    InputPath = InPath;
end

switch InputFile{1}
    case 0
        
    otherwise
        CurrentLength = 1;
        while isempty(handles.FilesToIncorporateList{CurrentLength,WhichInput}) == 0
           CurrentLength = CurrentLength+1; 
        end
        CurrentLength = CurrentLength-1;
        for i = 1:length(InputFile)
            handles.FilesToIncorporateList{CurrentLength+i,WhichInput} = [InputPath handles.PathSep InputFile{i}];
        end
        set(handles.FilesToIncorporateListBox,'value',1);
        handles = FilesToIncorporateListToDisplay(handles);
        set(handles.FilesToIncorporateListBox,'string',handles.FilesToIncorporateDisplay(:,WhichInput)); 
        guidata(handles.figure1,handles);
end



% --- Executes during object creation, after setting all properties.
function SearchPathForAddTrials_CreateFcn(hObject, eventdata, handles)
% hObject    handle to SearchPathForAddTrials (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in AddReader.
function AddReader_Callback(hObject, eventdata, handles)
% hObject    handle to AddReader (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

Input = inputdlg('Enter A Name for the Reader');

switch isempty(Input)
    case 1
        
    case 0
        fid = fopen([handles.ReaderClassPath handles.PathSep Input{1} '.m'],'w');
        fprintf(fid,['function ReaderOutput = ' Input{1} '(ReaderInput)\n']);
        fprintf(fid,'\n');
        fprintf(fid,'%% Readers are .m functions that look at data files and produce standard matlab data\n');
        fprintf(fid,'\n');
        fprintf(fid,'%% ReaderInput\n');
        fprintf(fid,'%%     .Files - cell array of file names passed to the reader\n');
        fprintf(fid,'%%     .HelperFunctions - cell array of helper function names to be used with EnableHelperFunction\n');
        fprintf(fid,'%%     .ProgramStatusIndicator - a handle to the Program Status Indicator on the front panel so that status can be updated from within the reader\n');
        fprintf(fid,'\n');
        fprintf(fid,'%% ReaderOutput\n');
        fprintf(fid,'%%     .Data - a struct (of arbitrary structure) that you want written to the trial file\n');
        fprintf(fid,'%%     .ReaderName - a string naming the data so that the trial file will have Trial.ReaderName = Data\n');
        fprintf(fid,'%%     .TrialName - a string that either names the trial or is empty.  The reader producing a trial name must be run first\n');
        fprintf(fid,'%%     .TrialDescription - a string describing the trial so that Trial.TrialDescription = TrialDescription\n');
        
        
        
        fclose(fid);
        handles = UpdateReaderList(handles);
        guidata(handles.figure1,handles);
end

% --- Executes on button press in RemoveReader.
function RemoveReader_Callback(hObject, eventdata, handles)
% hObject    handle to RemoveReader (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

Selected = get(handles.ReaderListBox,'value');

Answer = questdlg(['Are you sure you want to delete the method ' handles.ReaderNames{Selected} ' ?']);

switch Answer
    case 'Yes'
        delete([handles.ReaderClassPath handles.PathSep handles.ReaderNames{Selected}]);
        handles = UpdateReaderList(handles);
    case 'No'
        
    case 'Cancel'
end

set(handles.ReaderListBox,'value',1);

guidata(handles.figure1,handles);

% --- Executes on button press in ChooseCollectionMethodClass.
function ChooseCollectionMethodClass_Callback(hObject, eventdata, handles)
% hObject    handle to ChooseCollectionMethodClass (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

cd('CollectionMethods');
handles.CollectionClassPath = uigetdir;
cd(handles.RootDirectory);

set(handles.CollectionMethodsListBox,'value',1);


switch handles.CollectionClassPath
    case 0 
        return;
    otherwise
        handles = UpdateCollectionMethodList(handles);
        guidata(handles.figure1,handles);
end

% --- Executes on button press in ChooseReaderClass.
function ChooseReaderClass_Callback(hObject, eventdata, handles)
% hObject    handle to ChooseReaderClass (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

cd('Readers');
handles.ReaderClassPath = uigetdir;
cd(handles.RootDirectory);

switch handles.ReaderClassPath
    case 0
        return;
    otherwise
        handles = UpdateReaderList(handles);
        guidata(handles.figure1,handles);
end

set(handles.ReaderListBox,'value',1);


% --------------------------------------------------------------------
function OpenTextFile_Callback(hObject, eventdata, handles)
% hObject    handle to OpenTextFile (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

Selected = get(handles.FilesToIncorporateListBox,'value');
WhichInput = get(handles.InputNumberSelector,'value');

open(handles.FilesToIncorporateList{Selected,WhichInput});


% --------------------------------------------------------------------
function RightClickFilesToIncorporate_Callback(hObject, eventdata, handles)
% hObject    handle to RightClickFilesToIncorporate (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in LoadTrialsToAnalyze.
function LoadTrialsToAnalyze_Callback(hObject, eventdata, handles)
% hObject    handle to LoadTrialsToAnalyze (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

[File,Path] = uigetfile('load trials to analyze');

load([Path handles.PathSep File]);

handles.AnalyzeFileList = AnalyzeFileList;

set(handles.TrialsToAnalyzeListBox,'value',1);
handles = AnalyzeFileListToDisplay(handles);
set(handles.TrialsToAnalyzeListBox,'string',handles.AnalyzeFileDisplay);

guidata(handles.figure1,handles);

% --- Executes on button press in SaveTrialsToAnalyze.
function SaveTrialsToAnalyze_Callback(hObject, eventdata, handles)
% hObject    handle to SaveTrialsToAnalyze (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

[SaveFile,SavePath] = uiputfile('','save trials to analyze');

AnalyzeFileList = handles.AnalyzeFileList;

save([SavePath handles.PathSep SaveFile],'AnalyzeFileList');


% --- Executes on button press in SetToFtp.
function SetToFtp_Callback(hObject, eventdata, handles)
% hObject    handle to SetToFtp (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of SetToFtp


% --------------------------------------------------------------------
function AboutDatabaser_Callback(hObject, eventdata, handles)
% hObject    handle to AboutDatabaser (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

c = dir;

i = find(strcmp({c.name},'Databaser.m')==1);

msgbox(['Databaser is a tool for organizing experimental data, most useful when the ''Experiment/Session/Trial'' framework applies. Databaser was developed by Jason J. Kutch, Ph.D., at the University of Southern California.  See the Lab Wiki for help using the databaser.  Databaser was last modified ' c(i).date '.'],'About Databaser','Help');


% --------------------------------------------------------------------
function Readme_Callback(hObject, eventdata, handles)
% hObject    handle to Readme (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

open README.pdf


% --- Executes on button press in LoadResultsToPublish.
function LoadResultsToPublish_Callback(hObject, eventdata, handles)
% hObject    handle to LoadResultsToPublish (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

[File,Path] = uigetfile('load results to publish');

load([Path handles.PathSep File]);

handles.PublishFileList = PublishFileList;

set(handles.ResultsToPublishListBox,'value',1);
handles = PublishResultListToDisplay(handles)
set(handles.ResultsToPublishListBox,'string',handles.PublishFileDisplay);

guidata(handles.figure1,handles);


% --- Executes during object creation, after setting all properties.
function LoadTrialsToAnalyze_CreateFcn(hObject, eventdata, handles)
% hObject    handle to LoadTrialsToAnalyze (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --------------------------------------------------------------------
function RightClickResults_Callback(hObject, eventdata, handles)
% hObject    handle to RightClickResults (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function ViewResultInArrayEditor_Callback(hObject, eventdata, handles)
% hObject    handle to ViewResultInArrayEditor (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

Selected = get(handles.ResultsToPublishListBox,'value');

load(handles.PublishFileList{Selected});

if exist('Result') == 1
    assignin('base','Result',Result);
    openvar('Result');
end

if exist('Model') == 1
    assignin('base','Model',Model);
    openvar('Model')
end


% --------------------------------------------------------------------
function HelperFunctionMenu_Callback(hObject, eventdata, handles)
% hObject    handle to HelperFunctionMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function Untitled_1_Callback(hObject, eventdata, handles)
% hObject    handle to Untitled_1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

cd('HelperFunctions');

[File,Path] = uiputfile({'*.m';'*.c'},'Helper function name');

if File ~= 0
    edit([Path File]);
end
    
cd(handles.RootDirectory);

% --------------------------------------------------------------------
function EditHelperFunction_Callback(hObject, eventdata, handles)
% hObject    handle to EditHelperFunction (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

cd('HelperFunctions');

[File,Path] = uigetfile({'*.m';'*.c'},'Helper function name');

if File ~= 0
    edit([Path File]);
end

cd(handles.RootDirectory);


% --------------------------------------------------------------------
function FinderHelperFunctions_Callback(hObject, eventdata, handles)
% hObject    handle to FinderHelperFunctions (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

switch handles.IsThisAMac
    case 1
        system('open HelperFunctions');
    case 0
        errordlg('This feature only available in Mac OSX');
end


% --- Executes on button press in SaveResultsToPublish.
function SaveResultsToPublish_Callback(hObject, eventdata, handles)
% hObject    handle to SaveResultsToPublish (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

[SaveFile,SavePath] = uiputfile('','Save results to publish');

PublishFileList = handles.PublishFileList;

save([SavePath handles.PathSep SaveFile],'PublishFileList');


% --------------------------------------------------------------------
function GetTrialDescription_Callback(hObject, eventdata, handles)
% hObject    handle to GetTrialDescription (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

Selected = get(handles.TrialsToAnalyzeListBox,'value');
load(handles.AnalyzeFileList{Selected});
h = msgbox(Trial.Description);
DatabaserPos = get(handles.figure1,'position');
MsgBoxPos = get(h,'position');
set(h,'position',[DatabaserPos(1) DatabaserPos(2) MsgBoxPos(3) MsgBoxPos(4)]); 


% --- Executes on button press in Set2FtpForBuild.
function Set2FtpForBuild_Callback(hObject, eventdata, handles)
% hObject    handle to Set2FtpForBuild (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of Set2FtpForBuild


% --- Executes on button press in Pdf2Desktop.
function Pdf2Desktop_Callback(hObject, eventdata, handles)
% hObject    handle to Pdf2Desktop (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

h = msgbox('Select Figure to Print...');
uiwait(h);
BaseDir = cd;
[status,result] = system('whoami');
cd(['/Users/' result(1:end-1) '/Desktop'])

switch get(handles.RoughType,'value')
    case 1
        print(gcf,'rough.pdf','-dpdf');
    case 2
        print(gcf,'rough.eps','-depsc');
end
        
cd(BaseDir);


% --- Executes on button press in CopyGcaPosition.
function CopyGcaPosition_Callback(hObject, eventdata, handles)
% hObject    handle to CopyGcaPosition (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

h = msgbox('Select Axes...');
uiwait(h);
Pos = get(gca,'position');
str = mat2str(Pos,4);
clipboard('copy',str(2:end-1));


% --- Executes on selection change in RoughType.
function RoughType_Callback(hObject, eventdata, handles)
% hObject    handle to RoughType (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns RoughType contents as cell array
%        contents{get(hObject,'Value')} returns selected item from RoughType


% --- Executes during object creation, after setting all properties.
function RoughType_CreateFcn(hObject, eventdata, handles)
% hObject    handle to RoughType (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --------------------------------------------------------------------
function LabWikiMenu_Callback(hObject, eventdata, handles)
% hObject    handle to LabWikiMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on selection change in LabWikiListbox.
function LabWikiListbox_Callback(hObject, eventdata, handles)
% hObject    handle to LabWikiListbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns LabWikiListbox contents as cell array
%        contents{get(hObject,'Value')} returns selected item from LabWikiListbox


% --- Executes during object creation, after setting all properties.
function LabWikiListbox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to LabWikiListbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in AddNewWiki.
function AddNewWiki_Callback(hObject, eventdata, handles)
% hObject    handle to AddNewWiki (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

b = inputdlg('New Wiki Document Name','New Wiki Document');

switch (ismac||isunix)
    case 1
        system(['cp WikiTemplate.tex Wiki/' b{1} '.tex']);
        system(['touch Wiki/' b{1} '.pdf']);
    case 0
        copyfile('WikiTemplate.tex',['Wiki\' b{1} '.tex']);
end

handles = UpdateWikiList(handles);

guidata(handles.figure1,handles);


% --- Executes on button press in RemoveWiki.
function RemoveWiki_Callback(hObject, eventdata, handles)
% hObject    handle to RemoveWiki (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

Selected = get(handles.LabWikiListbox,'value');

Answer = questdlg(['Are you sure you want to delete the wiki ' handles.WikiNames{Selected} ' ?']);

switch Answer
    case 'Yes'
        delete(['Wiki' handles.PathSep handles.WikiNames{Selected} '.*']);
        handles = UpdateWikiList(handles);
    case 'No'
        
    case 'Cancel'
end

guidata(handles.figure1,handles);


% --------------------------------------------------------------------
function EditTrialDescription_Callback(hObject, eventdata, handles)
% hObject    handle to EditTrialDescription (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

SelTrial = get(handles.TrialsToAnalyzeListBox,'value');
load(handles.AnalyzeFileList{SelTrial});

b = inputdlg('Edit Trial Description','Trial Description',1,{Trial.Description});

switch isempty(b)
    case 1
        
    case 0
        Trial.Description = b{1};
        save(handles.AnalyzeFileList{SelTrial},'Trial');
end
        
        


% --- Executes on button press in EditWiki.
function EditWiki_Callback(hObject, eventdata, handles)
% hObject    handle to EditWiki (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

SelWiki = get(handles.LabWikiListbox,'value');

BaseDirectory = cd;

cd('Wiki');

switch (ismac||isunix)
    case 1
        system(['open ' handles.WikiNames{SelWiki} '.tex']);
    case 0
        dos([handles.WikiNames{SelWiki} '.tex']);
end

cd(BaseDirectory);


% --- Executes on button press in OpenWiki.
function OpenWiki_Callback(hObject, eventdata, handles)
% hObject    handle to OpenWiki (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

SelWiki = get(handles.LabWikiListbox,'value');
BaseDirectory = cd;
cd('Wiki');

switch ismac
    case 1
        system(['open ' handles.WikiNames{SelWiki} '.pdf']);
    case 0
        open([handles.WikiNames{SelWiki} '.pdf']);
end
    

cd(BaseDirectory);


% --------------------------------------------------------------------
function UserMenu_Callback(hObject, eventdata, handles)
% hObject    handle to UserMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function LoadConfigMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to LoadConfigMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

strsep = EnableHelperFunction([],{'strsep.m'});

BaseDirectory = cd;

cd('UserConfigFiles');
[File,Path] = uigetfile('*.mat','Load Config');

switch File
    case 0
        cd(BaseDirectory);
    otherwise

handles.ConfigFile = [Path File];

load(handles.ConfigFile);
cd(BaseDirectory);


handles.AnalyzeClassPath = AnalyzeClassPath;
handles = UpdateAnalysisMethodList(handles);

handles.ReaderClassPath = ReaderClassPath;
handles = UpdateReaderList(handles);


handles.PublishClassPath = PublishClassPath;
handles = UpdatePublishingMethodList(handles);

handles.CollectionClassPath = CollectionClassPath;
handles = UpdateCollectionMethodList(handles);

handles.ActiveExperiment = ActiveExperiment;
set(handles.ActiveExperimentIndicator,'string',handles.ActiveExperiment);

handles.ActiveSession = ActiveSession;
set(handles.ActiveSessionIndicator,'string',handles.ActiveSession);

handles.PathForAddTrials = PathForAddTrials;
set(handles.PathForAddTrialsIndicator,'string',handles.PathForAddTrials);
handles.PathForAddResults = PathForAddResults;
set(handles.ResultPathIndicator,'string',handles.PathForAddResults);

handles.AnalyzeFileList = AnalyzeFileList;
handles.PublishFileList = PublishFileList;

set(handles.TrialsToAnalyzeListBox,'value',1);
handles = AnalyzeFileListToDisplay(handles);
set(handles.TrialsToAnalyzeListBox,'string',handles.AnalyzeFileDisplay);

set(handles.ResultsToPublishListBox,'value',1);
handles = PublishResultListToDisplay(handles);
set(handles.ResultsToPublishListBox,'string',handles.PublishFileDisplay);

temp = strsep(File,'.');
set(handles.CurrentConfigIndicator,'string',temp{1});

guidata(handles.figure1,handles);
end


% --------------------------------------------------------------------
function SaveConfigMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to SaveConfigMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

strsep = EnableHelperFunction([],{'strsep.m'});


BaseDirectory = cd;
cd('UserConfigFiles');

if isempty(handles.ConfigFile) == 1
    [File,Path] = uiputfile('*.mat','Save Config');
    savefile = [Path File];
else
    savefile = handles.ConfigFile;
end

AnalyzeClassPath = handles.AnalyzeClassPath;
ReaderClassPath = handles.ReaderClassPath;
PublishClassPath = handles.PublishClassPath;
CollectionClassPath = handles.CollectionClassPath;

ActiveExperiment = handles.ActiveExperiment;
ActiveSession = handles.ActiveSession;

PathForAddTrials = handles.PathForAddTrials;
PathForAddResults = handles.PathForAddResults;

AnalyzeFileList = handles.AnalyzeFileList;
PublishFileList = handles.PublishFileList;

save(savefile,'PublishFileList','AnalyzeFileList','AnalyzeClassPath','ReaderClassPath','PublishClassPath','CollectionClassPath','ActiveExperiment','ActiveSession','PathForAddTrials','PathForAddResults');

handles.ConfigFile = savefile;

temp = strsep(savefile,'.');
set(handles.CurrentConfigIndicator,'string',temp{1});

cd(BaseDirectory);

guidata(handles.figure1,handles);

% --------------------------------------------------------------------
function SaveConfigAsMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to SaveConfigAsMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

strsep = EnableHelperFunction([],{'strsep.m'});


BaseDirectory = cd;
cd('UserConfigFiles');

[File,Path] = uiputfile('*.mat','Save Config');
savefile = [Path File];



AnalyzeClassPath = handles.AnalyzeClassPath;
ReaderClassPath = handles.ReaderClassPath;
PublishClassPath = handles.PublishClassPath;
CollectionClassPath = handles.CollectionClassPath;

ActiveExperiment = handles.ActiveExperiment;
ActiveSession = handles.ActiveSession;

PathForAddTrials = handles.PathForAddTrials;
PathForAddResults = handles.PathForAddResults;

AnalyzeFileList = handles.AnalyzeFileList;
PublishFileList = handles.PublishFileList;

save(savefile,'PublishFileList','AnalyzeFileList','AnalyzeClassPath','ReaderClassPath','PublishClassPath','CollectionClassPath','ActiveExperiment','ActiveSession','PathForAddTrials','PathForAddResults');

handles.ConfigFile = savefile;

temp = strsep(savefile,handles.PathSep);
temp2 = strsep(temp{end},'.');
set(handles.CurrentConfigIndicator,'string',temp2{1});


cd(BaseDirectory);

guidata(handles.figure1,handles);


function FtpAddress_Callback(hObject, eventdata, handles)
% hObject    handle to FtpAddress (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of FtpAddress as text
%        str2double(get(hObject,'String')) returns contents of FtpAddress as a double


% --- Executes during object creation, after setting all properties.
function FtpAddress_CreateFcn(hObject, eventdata, handles)
% hObject    handle to FtpAddress (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in MoveTrialUp.
function MoveTrialUp_Callback(hObject, eventdata, handles)
% hObject    handle to MoveTrialUp (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

Selected = get(handles.TrialsToAnalyzeListBox,'Value');

switch Selected
    case 1
        
    otherwise
        temp = handles.AnalyzeFileList{Selected};
        handles.AnalyzeFileList{Selected} = handles.AnalyzeFileList{Selected-1};
        handles.AnalyzeFileList{Selected-1} = temp;
end

handles = AnalyzeFileListToDisplay(handles);
set(handles.TrialsToAnalyzeListBox,'string',handles.AnalyzeFileDisplay);
set(handles.TrialsToAnalyzeListBox,'value',Selected-1);

guidata(handles.figure1,handles);


% --- Executes on button press in MoveTrialDown.
function MoveTrialDown_Callback(hObject, eventdata, handles)
% hObject    handle to MoveTrialDown (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

Selected = get(handles.TrialsToAnalyzeListBox,'Value');

switch Selected
    case length(handles.AnalyzeFileList)
        
    otherwise
        temp = handles.AnalyzeFileList{Selected};
        handles.AnalyzeFileList{Selected} = handles.AnalyzeFileList{Selected+1};
        handles.AnalyzeFileList{Selected+1} = temp;
end

handles = AnalyzeFileListToDisplay(handles);
set(handles.TrialsToAnalyzeListBox,'string',handles.AnalyzeFileDisplay);
set(handles.TrialsToAnalyzeListBox,'value',Selected+1);
        
guidata(handles.figure1,handles);



function CurrentConfigIndicator_Callback(hObject, eventdata, handles)
% hObject    handle to CurrentConfigIndicator (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of CurrentConfigIndicator as text
%        str2double(get(hObject,'String')) returns contents of CurrentConfigIndicator as a double


% --- Executes during object creation, after setting all properties.
function CurrentConfigIndicator_CreateFcn(hObject, eventdata, handles)
% hObject    handle to CurrentConfigIndicator (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton72.
function pushbutton72_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton72 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function GetResultDescription_Callback(hObject, eventdata, handles)
% hObject    handle to GetResultDescription (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in AddResultFolder.
function AddResultFolder_Callback(hObject, eventdata, handles)
% hObject    handle to AddResultFolder (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

strsep = EnableHelperFunction(handles.HelperFunctions,'strsep.m');

switch isempty(handles.PathForAddResults)
    case 0
        [ResultPath] = uigetdir(handles.PathForAddResults,'Select a result');
    case 1
        [ResultPath] = uigetdir(cd,'Select a trial');
end

if ResultPath ~= 0
        
    handles.PublishFileList{length(handles.PublishFileList)+1} = ResultPath;
    set(handles.ResultsToPublishListBox,'value',1);
    handles = PublishResultListToDisplay(handles);
    set(handles.ResultsToPublishListBox,'string',handles.PublishFileDisplay);
    guidata(handles.figure1,handles);

end


% --- Executes on button press in AddIncorporateFolder.
function AddIncorporateFolder_Callback(hObject, eventdata, handles)
% hObject    handle to AddIncorporateFolder (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

strsep = EnableHelperFunction(handles.HelperFunctions,'strsep.m');

WhichInput = get(handles.InputNumberSelector,'value');

switch isempty(handles.PathForAddTrials)
    case 0
        [IncorporatePath] = uigetdir(handles.PathForAddTrials,'Select a folder to incorporate');
    case 1
        [IncorporatePath] = uigetdir(cd,'Select a folder to incorporate');
end

if IncorporatePath ~= 0
    
    CurrentLength = 1;
    while isempty(handles.FilesToIncorporateList{CurrentLength,WhichInput}) == 0
        CurrentLength = CurrentLength+1; 
    end
    handles.FilesToIncorporateList{CurrentLength,WhichInput} = IncorporatePath;
    set(handles.FilesToIncorporateListBox,'value',1);
    handles = FilesToIncorporateListToDisplay(handles);
    set(handles.FilesToIncorporateListBox,'string',handles.FilesToIncorporateDisplay(:,WhichInput)); 
    guidata(handles.figure1,handles);

end
