function ReaderOutput = Step0_Session(ReaderInput)
% this function puts together session info, as well as
% runs bet and saves the result.
% input type 1 - EV file, with first line being the session description
% input type 2 - mprage (nii.gz)

try
    A = ReaderInput.Files;
end

switch exist('A')
    case 0
        msgbox({'this function puts together session info, as well as';'runs bet and saves the result.';'input type 1 - EV file, with first line being the session description';'input type 2 - mprage (nii.gz)'});
        uiwait;
        
        ReaderOutput.TrialName = [];
        ReaderOutput.Data = 1;
    otherwise

file2str = EnableHelperFunction([],'file2str.m');
BaseDirectory = cd;
home;

try

    FslStr = 'FSLDIR=/usr/local/fsl ; PATH=${FSLDIR}/bin:${PATH} ; . ${FSLDIR}/etc/fslconf/fsl.sh ; export FSLDIR PATH';
    strsep = EnableHelperFunction([],{'strsep.m'});

    ReaderOutput.ReaderName = 'Session';

    ReaderOutput.TrialDescription = file2str(ReaderInput.Files{1});

    temp = strsep(ReaderInput.Files{1},ReaderInput.PathSep);
    temp2 = strsep(temp{end},'.');
    ReaderOutput.TrialName = temp2{1};

    cd('HelperFunctions/nifti/');

    system(['gunzip ' ReaderInput.Files{2}]); 
    mprage = load_nii(ReaderInput.Files{2}(1:end-3));
    system(['gzip ' ReaderInput.Files{2}(1:end-3)]);

    ReaderOutput.Data.mprage = mprage;

    system([FslStr '; fslview ' ReaderInput.Files{2} ' &']);

    CenterStr = inputdlg({'X';'Y';'Z'},'brain center',1);

    ReaderOutput.Data.mprage_center.X = str2num(CenterStr{1});
    ReaderOutput.Data.mprage_center.Y = str2num(CenterStr{2});
    ReaderOutput.Data.mprage_center.Z = str2num(CenterStr{3});
    ReaderOutput.Data.mprage_center.Units = 'Voxel number in FSL coordinates';

    set(ReaderInput.ProgramStatusIndicator,'string','Running bet','foregroundcolor','green');drawnow;

    system([FslStr '; bet ' ReaderInput.Files{2} ' ' ReaderInput.Files{2}(1:end-7) '_brain.nii.gz -B -S -c ' CenterStr{1} ' ' CenterStr{2} ' ' CenterStr{3}]);

    set(ReaderInput.ProgramStatusIndicator,'string','Finished bet');drawnow;

    file = ReaderInput.Files{2}(1:end-7);

    system(['gunzip ' file '_brain.nii.gz']); 
    mprage_brain = load_nii([file '_brain.nii']);
    system(['gzip ' file '_brain.nii']);
    ReaderOutput.Data.mprage_brain = mprage_brain;

    cd(BaseDirectory);

    set(ReaderInput.ProgramStatusIndicator,'string','Ready.');drawnow;

catch err
    
    set(ReaderInput.ProgramStatusIndicator,'string','Reader Step0_Session exited with an error. See matlab window for details.','foregroundcolor','r');drawnow;
    pause(2);
    set(ReaderInput.ProgramStatusIndicator,'string','Ready.','foregroundcolor','k');drawnow;
    cd(BaseDirectory);
    
    ReaderOutput.Data = [];
    
    rethrow(err);
    
end
        
        
end


