function ReaderOutput = Step2_AddPostStat(ReaderInput)
% input1 - zstat resulting from fsl analysis
% input2 - .fsf design file associated with stat

DateAndTimeStr = EnableHelperFunction([],'DateAndTimeStr.m');

BaseDirectory = cd;
home;

FslStr = 'FSLDIR=/usr/local/fsl ; PATH=${FSLDIR}/bin:${PATH} ; . ${FSLDIR}/etc/fslconf/fsl.sh ; export FSLDIR PATH';

try

    load(ReaderInput.IntoTrial);
    [path,file] = fileparts(ReaderInput.IntoTrial);

    BaseDirectory = cd;

    switch isfield(Trial,'Stats')
        case 1
           Stats = Trial.Stats;
           NumStats = length(Stats);
           % read post-stat data
            cd('HelperFunctions/nifti');
            system(['gunzip ' ReaderInput.Files{1}]); 
            nii = load_nii(ReaderInput.Files{1}(1:end-3));
            system(['gzip ' ReaderInput.Files{1}(1:end-3)]);

            ans = inputdlg('Enter a description for this stat','StatDescription',1);
            Stats(NumStats+1).Description = ans{1};

            [designpath,designfile] = fileparts(ReaderInput.Files{2});
            Stats(NumStats+1).DesignFile = [path '/FslDesigns/' designfile '_' DateAndTimeStr() '.fsf'];
   %         copyfile(ReaderInput.Files{2},Stats(NumStats+1).DesignFile);

            Stats(NumStats+1).zstat = nii;

        case 0
            NumStats = 0;
           % read post-stat data
            cd('HelperFunctions/nifti');
            system(['gunzip ' ReaderInput.Files{1}]); 
            nii = load_nii(ReaderInput.Files{1}(1:end-3));
            system(['gzip ' ReaderInput.Files{1}(1:end-3)]);

            ans = inputdlg('Enter a description for this stat','StatDescription',1);
            Stats(NumStats+1).Description = ans{1};

            [designpath,designfile] = fileparts(ReaderInput.Files{2});
            Stats(NumStats+1).DesignFile = [path '/FslDesigns/' designfile '_' DateAndTimeStr() '.fsf'];
       %     copyfile(ReaderInput.Files{2},Stats(NumStats+1).DesignFile);

            Stats(NumStats+1).zstat = nii;



    end

    cd(BaseDirectory);

    ReaderOutput.ReaderName = 'Stats';
    ReaderOutput.TrialName = '';
    ReaderOutput.TrialDescription = '';
    ReaderOutput.Data = Stats;
    
catch err
    
    set(ReaderInput.ProgramStatusIndicator,'string','Reader Step2_AddFslStat exited with an error. See matlab window for details.','foregroundcolor','r');drawnow;
    pause(2);
    set(ReaderInput.ProgramStatusIndicator,'string','Ready.','foregroundcolor','k');drawnow;
    cd(BaseDirectory);
    
    ReaderOutput.Data = [];
    
    rethrow(err);
    
end




