function ReaderOutput = Read2hand(ReaderInput)

% Readers are .m functions that look at data files and produce standard matlab data

% ReaderInput
%     .Files - cell array of file names passed to the reader
%     .HelperFunctions - cell array of helper function names to be used with EnableHelperFunction
%     .ProgramStatusIndicator - a handle to the Program Status Indicator on the front panel so that status can be updated from within the reader

% ReaderOutput
%     .Data - a struct (of arbitrary structure) that you want written to the trial file
%     .ReaderName - a string naming the data so that the trial file will have Trial.ReaderName = Data
%     .TrialName - a string that either names the trial or is empty.  The reader producing a trial name must be run first
%     .TrialDescription - a string describing the trial so that Trial.TrialDescription = TrialDescription
load(ReaderInput.Files{1})
trial=cellfun(@str2num,BGdata(5:6),'uniformoutput',0);
age=BGdata{2};
sex=BGdata{3};
handedness=BGdata{4};

[path,name,ext]=fileparts(ReaderInput.Files{1});
%name=P1_005
%ext= .mat
%cd(fullfile(path,name))

cd(fullfile('C:\Users\JellyBee\Documents\BME11spring\BBDL\RERC_Data',name))
%subFolder=what;
%trialEXP=['^f_' name '(\d+)\.mat$'];
%trialNUM=cellfun(@(x)str2num(regexp(subFolder.mat,trialEXP,'tokens'))

ReaderOutput.TrialName =['db' name ];
ReaderOutput.TrialDescription = 'Not available';

ReaderOutput.ReaderName = 'SDdata';
ReaderOutput.Data.Subject = name;
ReaderOutput.Data.Age = age;
ReaderOutput.Data.Sex = sex;
ReaderOutput.Data.Handedness = handedness;
ReaderOutput.Data.ForceData.SamplingFrequency= {400 'Hz'};

handID={'DominantHand' 'nonDominantHand'};
for i=1:length(handID) %1:dominant hand 2:non-DH
    clear Trial
    for j=1:length(trial{i})
%         trial{i}(j)
%         trialName=['f_' name '.*' num2str(trial{i}(j)) '\.mat'];   'f_P1_012015.mat'
%         regexpi(subFolder.mat,trialName,'match')
%         cellfun(@(x)isempty(regexpi(x,trialName,'match')),subFolder.mat)
%         subFolder.mat{find(1-cellfun(@(x)isempty(regexpi(x,trialName,'match')),subFolder.mat))}
%         load(subFolder.mat{find(1-cellfun(@(x)isempty(regexpi(x,trialName,'match')),subFolder.mat))})

trialName=['f_' name sprintf('%03d',trial{i}(j)) '.mat'];
Trial(j).TrialNumber=trial{i}(j);
if exist(trialName)
load(trialName)
Trial(j).Value=[forceData{1};forceData{3}];
Trial(j).Label={'thumb (gw)';'index (gw)'};

else
Trial(j).Value='missing';
Trial(j).Label=nan;
end
    end
    ReaderOutput.Data.ForceData=setfield(ReaderOutput.Data.ForceData,handID{i},Trial);
end

return