function ReaderOutput = TapRead(ReaderInput)
% Readers are .m functions that look at data files and produce standard matlab data

% ReaderInput
%     .Files - cell array of file names passed to the reader
%     .HelperFunctions - cell array of helper function names to be used with EnableHelperFunction
%     .ProgramStatusIndicator - a handle to the Program Status Indicator on the front panel so that status can be updated from within the reader

% ReaderOutput
%     .Data - a struct (of arbitrary structure) that you want written to the trial file
%     .ReaderName - a string naming the data so that the trial file will have Trial.ReaderName = Data
%     .TrialName - a string that either names the trial or is empty.  The reader producing a trial name must be run first
%     .TrialDescription - a string describing the trial so that Trial.TrialDescription = TrialDescription

load(ReaderInput.Files{1})
[path,name,ext]=fileparts(ReaderInput.Files{1});
ReaderOutput.TrialName=name(3:end);
ReaderOutput.ReaderName='Tapping';
ReaderOutput.Data.subID=BGdata.value{1};
ReaderOutput.TrialDescription = 'Not available';
home=pwd;

 away=['C:\Users\JellyBee\Documents\BME11summer\databaserTest\ParkinsonsStudy\FingerTappingPD\Sub' sprintf('%03d',ReaderOutput.Data.subID)];
 cd(away)
file=what;

for cond={'FT_sm_c1','FT_sm_c2','FT_sm_c3','FT_rg_c1','FT_rg_c2','FT_rg_c3'};
   
clear trial X
trial=BGdata.value{find(cellfun(@(a)strcmp(a,cond),BGdata.label))};
if strcmp(class(trial),'char')
    trial=str2num(trial);
end
    for tr=1:length(trial)
    matchstr=['.*Trial_' num2str(trial(tr)) '.mat'];
    matchfile=find(cellfun(@(x)~isempty(regexp(x,matchstr)),file.mat));
    if isempty(matchfile)
        X=[];
    else
    load(file.mat{matchfile});
    % ReaderOutput.Data.Age = age;
    % ReaderOutput.Data.Sex = sex;
    % ReaderOutput.Data.Handedness = handedness;
    X(tr).ForceData=data(1:3,:);
    X(tr).SamplingFrequency=daqInfo.ObjInfo.SampleRate;
    X(tr).Time=time;
    X(tr).Label=[cond{:} '(' num2str(trial(tr)) ')'  ];
    
    end
   
    end

    ReaderOutput.Data=setfield(ReaderOutput.Data,cond{:},X);
    
end
